#include "GameFlow.h"
using namespace BWAPI;
using namespace BWTA;
using namespace std;
GameFlow *theGameFlow = NULL;

GameFlow* GameFlow::create()
{
	if (theGameFlow) return theGameFlow;
	else return theGameFlow = new GameFlow();
}

GameFlow::GameFlow()
{
	this->buildOrder = NULL;
	this->myInfor = NULL;
	this->enemyInfor = NULL;
	this->worker = NULL;
	this->lastFrameCheck = 0;
	this->stopGasTime =0 ;
	this->resumeGasTime = 0;
	this->stopGasFlag=false;
	this->scout = NULL;
	this->vulPri = 63;
	this->tankPri = 63;
	this->goliathPri = 62;
	this->choke = NULL;
	this->bunkerPosition = NULL;
	this->upgradeManager = NULL;
	this->secondBaseTile = TilePositions::None;
	this->mental = NULL;
	this->mapDroppable = false;
}

void GameFlow::setManagers(BuildOrderManager* bom,UpgradeManager* um)
{
	this->bmc = BaseManager::create();
	this->choke = ChokepointManager::create();
	this->buildOrder = bom;
	this->myInfor = MyInforManager::create();
	this->enemyInfor = EnemyInforManager::create();
	this->worker = WorkerManager::create();
	this->scout = ScoutManager::create();
	this->upgradeManager = um;
	this->mental = MentalClass::create();
	this->mapDroppable = !this->choke->dropReg.empty();
}

void GameFlow::stopGasTimeSlotSet(int time1,int time2,int stoplevel,int resumelevel)
{
	if (Broodwar->getFrameCount() - time2>24*5)
		return;
	if (Broodwar->getFrameCount()>=time1 && Broodwar->getFrameCount()<time2){
		this->worker->setNeedGasLevel(stoplevel);
		this->stopGasFlag =true;
	}
	if (Broodwar->getFrameCount()>=time2){
		this->worker->setNeedGasLevel(resumelevel);
		this->stopGasFlag =false;
	}
}

void GameFlow::onUnitDiscover(Unit* u)
{
	//
}

void GameFlow::factoryAutoTrain(int limitV,int limitT,int limitG,int priV,int priT,int priG)
{
	if (Broodwar->getFrameCount()%(24*3)==0 && limitV!=0){
		if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Vulture,30)<limitV){
			this->buildOrder->buildAdditional(1,UnitTypes::Terran_Vulture,priV);
		}
	}
	if (Broodwar->getFrameCount()%(24*3)==0 && limitT!=0){
		if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,30)<limitT){
			this->buildOrder->buildAdditional(1,UnitTypes::Terran_Siege_Tank_Tank_Mode,priT);
		}
	}
	if (Broodwar->getFrameCount()%(24*3)==0 && limitG!=0){
		if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Goliath,30)<limitG){
			this->buildOrder->buildAdditional(1,UnitTypes::Terran_Goliath,priG);
		}
	}

	else
		return;
}

void GameFlow::factoryTrainSet(int numV,int numT,int numG,int priV,int priT,int priG)
{
	if (Broodwar->getFrameCount()%24*5==0){
		if (numV!=0 && this->buildOrder->getPlannedCount(UnitTypes::Terran_Vulture,30)<numV)
			this->buildOrder->build(numV,UnitTypes::Terran_Vulture,priV);
		if (numT!=0 && this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,30)<numT)
			this->buildOrder->build(numT,UnitTypes::Terran_Siege_Tank_Tank_Mode,priT);
		if (numG!=0 && this->buildOrder->getPlannedCount(UnitTypes::Terran_Goliath,30)<numG)
			this->buildOrder->build(numG,UnitTypes::Terran_Goliath,priG);

	}
	else
		return;
}


void GameFlow::TZonFrame()
{
	//******** From here is strategy for Zerg*******************
	if (Broodwar->enemy()->getRace()==Races::Zerg){
		if (Broodwar->getFrameCount()%24*2==0){
			//gas control
			if (Broodwar->getFrameCount()%24*3==0 && this->myInfor->CountUnitNum(UnitTypes::Terran_Refinery,1)>0){
				if(Broodwar->self()->gas()-Broodwar->self()->minerals()>100 && Broodwar->self()->gas()>200 && Broodwar->self()->minerals()<500)
					this->worker->setWorkerPerGas(0);
				else{
					this->buildOrder->build(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1),UnitTypes::Terran_Refinery,80);
					this->worker->setNeedGasLevel(3);
					this->worker->setWorkerPerGas(3);
				}
			}

			//gas control end-------------------

			//for exceptions
			if((Broodwar->getFrameCount()>24*60*5 && Broodwar->self()->supplyUsed()/2<40&&Broodwar->self()->minerals()>2000)){
				//expand
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center,100)<4)
					this->buildOrder->autoExpand(100,4);
				//factory
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,73)<7){
					this->buildOrder->build(7,UnitTypes::Terran_Factory,73);
				}
				//add on
				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=5&&this->buildOrder->getPlannedCount(UnitTypes::Terran_Machine_Shop,72)<3){
					this->buildOrder->build(3,UnitTypes::Terran_Machine_Shop,72);
				}
				//army
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Goliath,70)<35){
					this->buildOrder->build(35,UnitTypes::Terran_Goliath,70);
				}
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,70)<35){
					this->buildOrder->build(35,UnitTypes::Terran_Siege_Tank_Tank_Mode,70);
				}

			}
			//delete bunker
			if (Broodwar->getFrameCount()>24*60*12 || Broodwar->self()->supplyUsed()/2>65){
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Bunker)>0)
					this->buildOrder->deleteItem(UnitTypes::Terran_Bunker);
			}
			//stage 1-------------------------------------------------fixed opening
			if (Broodwar->self()->supplyUsed()/2 ==10){
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Barracks,100)<1)
					this->buildOrder->build(1,UnitTypes::Terran_Barracks,100);
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Marine,63)<1)
					this->buildOrder->build(2,UnitTypes::Terran_Marine,63);
			}
			//if we have 2 marine(under training or already trained)
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Marine,1)>=2 && Broodwar->getFrameCount()%24==0){
				//expand 2nd base
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center,100)<2){
					if (this->mental->STflag && this->mental->STflag==MentalClass::ZrushZergling){
						if (this->myInfor->CountUnitNum(UnitTypes::Terran_Marine,1)>=13){
							this->buildOrder->autoExpand(100,2);
							this->buildOrder->build(1,UnitTypes::Terran_Refinery,99);
						}	
					}						
					else{
						this->buildOrder->autoExpand(100,2);
						this->buildOrder->build(1,UnitTypes::Terran_Refinery,99);
					}
				}

				//build a bunker
				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Bunker,2)<2 && this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)>=2){
					std::set<Unit*> mBase = SelectAll()(Command_Center);
					for each(Unit* bc in mBase){
						if (bc->getTilePosition().getDistance(Broodwar->self()->getStartLocation())<8)
							continue;
						else{
							this->secondBaseTile = bc->getTilePosition();
							
							Position mapCenter = Position(Broodwar->mapWidth()*16,Broodwar->mapHeight()*16);
							int minD = 9999;
							BWTA::Chokepoint* nearest_cp = NULL;
							for each (BWTA::Chokepoint* cp in BWTA::getRegion(bc->getTilePosition())->getChokepoints())
							{
								if (cp->getCenter().getApproxDistance(mapCenter) < minD)
								{
									nearest_cp = cp;
									minD = cp->getCenter().getApproxDistance(mapCenter);
								}
							}
							this->bunkerPosition = new TilePosition((bc->getTilePosition().x()+nearest_cp->getCenter().x()/32)/2,(bc->getTilePosition().y()+nearest_cp->getCenter().y()/32)/2);
							//this->bunkerPosition= new TilePosition((bc->getTilePosition().x()+BWTA::getNearestChokepoint(bc->getPosition())->getCenter().x()/32)/2,(bc->getTilePosition().y()+BWTA::getNearestChokepoint(bc->getPosition())->getCenter().y()/32)/2);
						}
					}

					if (this->mental->STflag==MentalClass::ZrushZergling && this->myInfor->CountUnitNum(UnitTypes::Terran_Bunker,1)>0)
						this->buildOrder->build(2,UnitTypes::Terran_Bunker,70,*this->bunkerPosition);
					else
						this->buildOrder->build(1,UnitTypes::Terran_Bunker,70,*this->bunkerPosition);
				}

				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Marine,63)<4){
					this->buildOrder->buildAdditional(1,UnitTypes::Terran_Marine,68);
				}				
			}
			//opening over, stage 2 begin--------------------------------------------------build some advanced buildings
			//first check if all necessary buildings for opening are constructed
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)>=2 && this->myInfor->CountUnitNum(UnitTypes::Terran_Bunker,1)>=1){
				//build two factories, one with machine shop
				this->buildOrder->build(2,UnitTypes::Terran_Factory,66);
				this->buildOrder->build(1,UnitTypes::Terran_Academy,67);
				//once one factory is finished
				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>0){
					this->buildOrder->build(1,UnitTypes::Terran_Armory,67);					
					this->buildOrder->build(1,UnitTypes::Terran_Machine_Shop,67);

				}

				//once we have armory, upgrade and build 6 goliath
				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Armory,2)>0){
					//this->buildOrder->build(1,UnitTypes::Terran_Engineering_Bay,67);
					if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Vehicle_Weapons)<1)
						this->buildOrder->upgrade(1,UpgradeTypes::Terran_Vehicle_Weapons,67);
					if (Broodwar->self()->minerals()>180 && this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,65)<3){
						this->buildOrder->build(3,UnitTypes::Terran_Factory,68);
					}
				}
				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Armory,1)>0 && this->upgradeManager->getPlannedLevel(UpgradeTypes::Charon_Boosters)<1
					&&this->myInfor->CountUnitNum(UnitTypes::Terran_Goliath,1)>=3 )
					this->buildOrder->upgrade(1,UpgradeTypes::Charon_Boosters,69);
				// If we have academy and population >42
				if (Broodwar->self()->supplyUsed()/2>=34 && this->myInfor->CountUnitNum(UnitTypes::Terran_Academy,1)>0)
					this->buildOrder->build(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1),UnitTypes::Terran_Comsat_Station,200);
				//factoryTrainSet(3,0,0,66,0,0);

				//produce dropship
				if (this->mapDroppable && Broodwar->self()->supplyUsed()/2>60 && Broodwar->self()->deadUnitCount(UnitTypes::Terran_Dropship) < 3)
				{
					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Starport,2) < 1)
					{
						this->buildOrder->build(1,UnitTypes::Terran_Starport,100);
						this->buildOrder->build(1,UnitTypes::Terran_Control_Tower,98);
					}
					else if (this->myInfor->CountUnitNum(UnitTypes::Terran_Starport,1) >= 1)
					{
						if (this->myInfor->CountUnitNum(UnitTypes::Terran_Dropship,2) < 1)
						{
							this->buildOrder->build(1,UnitTypes::Terran_Dropship,105);
						}
					}
				}
			}

			//stage 2 over, stage 3 begin------------------------build more factories,and train army
			//first check buildings for stage 2
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>0 && this->myInfor->CountUnitNum(UnitTypes::Terran_Armory,1)>0){
				//train goliath
				if (Broodwar->self()->minerals()>100 && 
					(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)<3 || this->buildOrder->getPlannedCount(UnitTypes::Terran_Goliath,65)<45) 
					&& Broodwar->getFrameCount()%24*5==0){
						this->buildOrder->buildAdditional(this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1),UnitTypes::Terran_Goliath,67);
				}
				//build more factories
				if (Broodwar->self()->minerals()>180 && SelectAll()(isTraining)(Factory).size()>0 
					&& this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,65)<4				
					&& SelectAll()(isTraining)(Factory).size()== SelectAll()(isCompleted)(Factory).size()){
						//if (Broodwar->self()->minerals()>=320)
						//	this->buildOrder->buildAdditional(1,UnitTypes::Terran_Factory,70);
						//else
						this->buildOrder->buildAdditional(1,UnitTypes::Terran_Factory,68);
				}

				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=4 && this->myInfor->CountUnitNum(UnitTypes::Terran_Goliath,1)>=10 &&
					Broodwar->self()->minerals()>200){
						if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,65)<6)
							this->buildOrder->buildAdditional(1,UnitTypes::Terran_Factory,70);
				}
				//if finish upgrading Terran_Vehicle_Weapons, then continue upgrade
				if (Broodwar->self()->getUpgradeLevel(UpgradeTypes::Terran_Vehicle_Weapons)>0 
					&& this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Vehicle_Plating)<1){
						this->buildOrder->upgrade(1,UpgradeTypes::Terran_Vehicle_Plating,68);
				}
				//if goliath > 30,expand 3rd base
				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Goliath,2)>=30 || ((Broodwar->self()->supplyUsed()/2)>=105 && Broodwar->self()->minerals()>=500)
					|| Broodwar->self()->minerals()>=1500)
					this->buildOrder->autoExpand(100,4);

				//produce dropship
				if (this->mapDroppable && Broodwar->self()->supplyUsed()/2>60 && Broodwar->self()->deadUnitCount(UnitTypes::Terran_Dropship) < 3)
				{
					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Starport,2) < 1)
					{
						this->buildOrder->build(1,UnitTypes::Terran_Starport,100);
						this->buildOrder->build(1,UnitTypes::Terran_Control_Tower,98);
					}
					else if (this->myInfor->CountUnitNum(UnitTypes::Terran_Starport,1) >= 1)
					{
						if (this->myInfor->CountUnitNum(UnitTypes::Terran_Dropship,2) < 1)
						{
							this->buildOrder->build(1,UnitTypes::Terran_Dropship,105);
						}
					}
				}
			}

			//stage 3 over, stage 4 begin----------------- build more advanced building and military, upgrade
			if((this->myInfor->CountUnitNum(UnitTypes::Terran_Goliath,1)>=42 || Broodwar->self()->supplyUsed()/2>=120) &&
				this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=5 && 
				this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)>=3 &&
				Broodwar->self()->supplyUsed()/2<=160){
					if (Broodwar->self()->getUpgradeLevel(UpgradeTypes::Terran_Vehicle_Weapons)==1 
						&& Broodwar->self()->getUpgradeLevel(UpgradeTypes::Terran_Vehicle_Plating)==1){
							if(this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Vehicle_Weapons)<3)
								this->buildOrder->upgrade(1,UpgradeTypes::Terran_Vehicle_Weapons,70);
					}
					//delete vulture and marine from build order list
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Marine,40)>0){
						this->buildOrder->deleteItem(UnitTypes::Terran_Marine,63);
						this->buildOrder->deleteItem(UnitTypes::Terran_Marine,68);
					}
					//build scanner
					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1)>=3 &&
						this->myInfor->CountUnitNum(UnitTypes::Terran_Comsat_Station,1)< this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1))
						this->buildOrder->build(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1),UnitTypes::Terran_Comsat_Station,80);
					//research siege mode
					if (!Broodwar->self()->hasResearched(TechTypes::Tank_Siege_Mode))
						this->buildOrder->research(TechTypes::Tank_Siege_Mode,70);
					// we need some tanks 
					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Machine_Shop,2)<3){
						this->buildOrder->build(3,UnitTypes::Terran_Machine_Shop,69);
					}	



					if (Broodwar->self()->minerals()>100 && this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,65)<24
						&& Broodwar->getFrameCount()%24*5==0){
							this->buildOrder->buildAdditional(1,UnitTypes::Terran_Siege_Tank_Tank_Mode,67);
							//Broodwar->printf("%d",this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,65));
							//this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)
					}

					if (Broodwar->self()->minerals()>100 && Broodwar->getFrameCount()%24*5==0 && 
						(this->myInfor->CountUnitNum(UnitTypes::Terran_Goliath,1)<36)){
							this->buildOrder->build(36,UnitTypes::Terran_Goliath,68);
							//Broodwar->printf("%d",this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,65));
					}
					if (Broodwar->self()->minerals()>1500)
						this->buildOrder->autoExpand(100,5);


					////train more army
					//if (Broodwar->getFrameCount()%24*3==0){
					//	if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Goliath,66)<45)
					//		this->buildOrder->buildAdditional(4,UnitTypes::Terran_Goliath,67);
					//}
			}
			//stage 4 over, final stage begin----------------- upgrade all technique that we need,more army, more expansion
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)>=2 && Broodwar->self()->supplyUsed()/2>160){
				//keep training army , the remains money is used for upgrade and research, expand
				//SelectAll(isTraining)(Factory).size()>0 &&SelectAll(isCompleted)(Factory).size()-SelectAll(isTraining)(Factory).size()<=1 &&
				if (Broodwar->self()->minerals()>150){
					if(this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,2)<8)
						this->buildOrder->build(8,UnitTypes::Terran_Factory,70);
					if(this->myInfor->CountUnitNum(UnitTypes::Terran_Armory,2)<2)
						this->buildOrder->build(2,UnitTypes::Terran_Armory,70);
					if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Vehicle_Weapons)<3)
						this->buildOrder->upgrade(3,UpgradeTypes::Terran_Vehicle_Weapons,70);
					if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Vehicle_Weapons)<3)
						this->buildOrder->upgrade(3,UpgradeTypes::Terran_Vehicle_Plating,70);
					if(this->buildOrder->getPlannedCount(UnitTypes::Terran_Science_Vessel,70)<2)
						this->buildOrder->build(2,UnitTypes::Terran_Science_Vessel,70);
				}
				//expand more
				if (Broodwar->self()->supplyUsed()/2>170 || (Broodwar->self()->minerals()>1500 &&Broodwar->self()->supplyUsed()/2>140)){
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center,100)<5)
						this->buildOrder->autoExpand(100,5);

					if (Broodwar->self()->supplyUsed()/2>180 && Broodwar->self()->minerals()>2500){
						if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center,100)<7)
							this->buildOrder->autoExpand(100,7);				
					}					
				}




				//if reach 200 population, decrease priority of training amry 
				if (Broodwar->getFrameCount()%24*5 ==0 && Broodwar->self()->supplyUsed()/2<200 && Broodwar->self()->minerals()>100){
					/*					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,65)<30)
					this->buildOrder->buildAdditional(4,UnitTypes::Terran_Siege_Tank_Tank_Mode,68);
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,65)<50)
					this->buildOrder->buildAdditional(5,UnitTypes::Terran_Goliath,67);*/
					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Goliath,1)<36)
						this->buildOrder->build(36,UnitTypes::Terran_Goliath,69);
					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,1)<30)
						this->buildOrder->build(36,UnitTypes::Terran_Siege_Tank_Tank_Mode,69);

				}

				if (Broodwar->getFrameCount()%(24*20)==0){
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Comsat_Station)<10)
						this->buildOrder->build(10,UnitTypes::Terran_Comsat_Station,80);
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center)<8)
						this->buildOrder->autoExpand(100,8);				
				}
			}
		}	
	}

	//******** From here is strategy for PROTOSS*******************
	//if enemy is protoss
	else if (Broodwar->enemy()->getRace()==Races::Protoss){
		//gas control
		if (Broodwar->getFrameCount()%24*3==0 && this->myInfor->CountUnitNum(UnitTypes::Terran_Refinery,1)>0){
			if(Broodwar->self()->gas()-Broodwar->self()->minerals()>20 && Broodwar->self()->gas()>170 && Broodwar->self()->minerals()<500)
				this->worker->setWorkerPerGas(0);
			//else if ((Broodwar->self()->isResearching(TechTypes::Spider_Mines)&&this->myInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,2)>0)||(Broodwar->self()->hasResearched(TechTypes::Spider_Mines)
			//	&&this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)<2&&Broodwar->getFrameCount()<24*60*5))
			//	this->worker->setWorkerPerGas(0);
			else if (this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)<2 && Broodwar->self()->gas()>=200)
				this->worker->setWorkerPerGas(0);
			else{
				this->buildOrder->build(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1),UnitTypes::Terran_Refinery,80);
				this->worker->setNeedGasLevel(3);
				this->worker->setWorkerPerGas(3);
			}
		}
		//gas control end-------------------
		//for exceptions
		//if( (Broodwar->self()->supplyUsed()/2>100&&Broodwar->self()->minerals()>1500)||(Broodwar->self()->minerals()>2500)){
		//	this->buildOrder->autoExpand(100,5);
		//}

		//prevent mined out
		if (this->bmc->getBaseSet().size()>=2 && this->bmc->getAllMineralSet().size()<20 && Broodwar->self()->minerals()>300 && Broodwar->self()->supplyUsed()/2>120){
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center,100)<this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1)+1){
				this->buildOrder->autoExpand(100,this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1)+1);
			}
		}

		//stage 1-------------------------------------------------fixed opening
		if (Broodwar->self()->supplyUsed()/2 ==12){
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Barracks,100)<1)
				this->buildOrder->build(1,UnitTypes::Terran_Barracks,130);
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Refinery,99)<1)
				this->buildOrder->build(1,UnitTypes::Terran_Refinery,125);
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,80)<1)
				this->buildOrder->build(1,UnitTypes::Terran_Factory,120);
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Marine,70)<4)
				this->buildOrder->build(4,UnitTypes::Terran_Marine,80);
		}
		//if we have 2 marine(under training or already trained)
		if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>0){
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Machine_Shop,72)<1)
				this->buildOrder->build(1,UnitTypes::Terran_Machine_Shop,72);
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Machine_Shop,1)>0){
				if (!Broodwar->self()->hasResearched(TechTypes::Spider_Mines)&&this->myInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,2)>0)
					this->buildOrder->research(TechTypes::Spider_Mines,74);
				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,2)<1)
					this->buildOrder->build(1,UnitTypes::Terran_Siege_Tank_Tank_Mode,72);
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Vulture,70)<6 &&this->myInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,1)>0)
					this->buildOrder->build(4,UnitTypes::Terran_Vulture,70);
				if(SelectAll()(isCompleted)(Siege_Tank,Vulture).size()==5 &&this->myInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,1)<3)
					this->buildOrder->build(3,UnitTypes::Terran_Siege_Tank_Tank_Mode,72);
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Marine,70)<6)
					this->buildOrder->buildAdditional(2,UnitTypes::Terran_Marine,70);
				

				//this->buildOrder->build(6,UnitTypes::Terran_Marine,71);
			}

			if ((this->myInfor->CountUnitNum(UnitTypes::Terran_Vulture,2)>=1 || this->enemyInfor->killedEnemyNum > 2) && 
				Broodwar->self()->minerals()>=20 && 
				this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1)<2)
				this->buildOrder->autoExpand(100,2);
		}
		//stage2------------------------
		if (this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)>=2 && this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1)<3){		
			//build a bunker
			//if (this->myInfor->CountUnitNum(UnitTypes::Terran_Bunker,2)<1){
				std::set<Unit*> mBase = SelectAll()(Command_Center);
				for each(Unit* bc in mBase){
					//if the base is at start location, then skip
					if (bc->getTilePosition().getDistance(Broodwar->self()->getStartLocation()) < 3)
						continue;
					else{
						if (BWTA::isConnected((TilePosition)BWTA::getRegion(Broodwar->self()->getStartLocation())->getCenter(),(TilePosition)bc->getRegion()->getCenter())){
							this->secondBaseTile = bc->getTilePosition();
							Position mapCenter = Position(Broodwar->mapWidth()*16,Broodwar->mapHeight()*16);
							int minD = 9999;
							BWTA::Chokepoint* nearest_cp = NULL;
							for each (BWTA::Chokepoint* cp in BWTA::getRegion(bc->getTilePosition())->getChokepoints())
							{
								if (cp->getCenter().getApproxDistance(mapCenter) < minD)
								{
									nearest_cp = cp;
									minD = cp->getCenter().getApproxDistance(mapCenter);
								}
							}
							this->bunkerPosition = new TilePosition((bc->getTilePosition().x()+nearest_cp->getCenter().x()/32)/2,(bc->getTilePosition().y()+nearest_cp->getCenter().y()/32)/2);
							//this->bunkerPosition= new TilePosition((bc->getTilePosition().x()+BWTA::getNearestChokepoint(bc->getPosition())->getCenter().x()/32)/2,(bc->getTilePosition().y()+BWTA::getNearestChokepoint(bc->getPosition())->getCenter().y()/32)/2);
						}			
					}
				}
				//check if 2nd base already has bunker 
				std::set<Unit*> mBunker = SelectAll()(Bunker);
				for each(Unit* bk in mBunker){
					if (bk->getTilePosition().getDistance(*this->bunkerPosition)<3)
						continue;

					else{
						if (this->myInfor->CountUnitNum(UnitTypes::Terran_Bunker,1)==0)
							this->buildOrder->build(1,UnitTypes::Terran_Bunker,100,*this->bunkerPosition);
						else if(this->myInfor->CountUnitNum(UnitTypes::Terran_Bunker,1)==1)
							this->buildOrder->build(2,UnitTypes::Terran_Bunker,100,*this->bunkerPosition);
					}
										

				}		
				
			//}	

			//build more factories and military force
			if (Broodwar->self()->minerals()>100 && this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,65)<4){
				if(this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,2)<3)
					this->buildOrder->build(3,UnitTypes::Terran_Factory,68);
			}
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=2){
				if (!Broodwar->self()->hasResearched(TechTypes::Tank_Siege_Mode)&&this->myInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,1)>3)
					this->buildOrder->research(TechTypes::Tank_Siege_Mode,78);	
				if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Ion_Thrusters)<1 && Broodwar->self()->supplyUsed()/2>60)
					this->buildOrder->upgrade(1,UpgradeTypes::Ion_Thrusters,68);
			}

			if (Broodwar->self()->minerals()>40 && this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)<3){
				if((this->myInfor->CountUnitNum(UnitTypes::Terran_Vulture,1)<36||this->buildOrder->getPlannedCount(UnitTypes::Terran_Vulture,65)<36)&& Broodwar->getFrameCount()%24*5==0)	
					this->buildOrder->buildAdditional(this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1),UnitTypes::Terran_Vulture,68);
				if((this->myInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,1)<30||this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,65)<30)&& Broodwar->getFrameCount()%24*7==0)	
					this->buildOrder->buildAdditional(this->myInfor->CountUnitNum(UnitTypes::Terran_Machine_Shop,1),UnitTypes::Terran_Siege_Tank_Tank_Mode,68);
			}
			if (Broodwar->self()->supplyUsed()/2>75 &&Broodwar->self()->minerals()>130&&this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=2){
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Comsat_Station,68)<2){
					this->buildOrder->build(1,UnitTypes::Terran_Academy,69);
					this->buildOrder->build(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1),UnitTypes::Terran_Comsat_Station,68);
				}			
			}
			if (Broodwar->self()->supplyUsed()/2>50 && this->buildOrder->getPlannedCount(UnitTypes::Terran_Marine,60)>0)
				this->buildOrder->deleteItem(UnitTypes::Terran_Marine,70);

			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,2)>=3 &&(Broodwar->self()->minerals()>180|| SelectAll()(isCompleted)(Siege_Tank,Vulture).size()>=12)){
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,65)<6){
					this->buildOrder->buildAdditional(1,UnitTypes::Terran_Factory,67);
				}			
			}
			if ((this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=5)){
				if (Broodwar->self()->supplyUsed()/2>100 && this->myInfor->CountUnitNum(UnitTypes::Terran_Machine_Shop,2)<2)
					this->buildOrder->build(2,UnitTypes::Terran_Machine_Shop,70);
			}
			//if (Broodwar->self()->minerals()>350 && this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=4 && this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)<3)
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=3 && Broodwar->self()->minerals()>350
				&& this->myInfor->myFightingValue().first>this->enemyInfor->enemyFightingValue().first 
				&& this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)<3 && Broodwar->self()->supplyUsed()/2>75)
				this->buildOrder->autoExpand(100,3);

			//produce dropship
			if (this->mapDroppable && Broodwar->self()->supplyUsed()/2>80 && Broodwar->self()->deadUnitCount(UnitTypes::Terran_Dropship) < 3)
			{
				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Starport,2) < 1)
				{
					this->buildOrder->build(1,UnitTypes::Terran_Starport,100);
					this->buildOrder->build(1,UnitTypes::Terran_Control_Tower,98);
				}
				else if (this->myInfor->CountUnitNum(UnitTypes::Terran_Starport,1) >= 1)
				{
					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Dropship,2) < 1)
					{
						this->buildOrder->build(1,UnitTypes::Terran_Dropship,105);
					}
				}
			}
		}	

		//stage 3-----------------------------------------------------
		if (this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1)>=3 && Broodwar->self()->supplyUsed()/2<=160){
			//for scanner
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Comsat_Station,68)<3 && Broodwar->self()->supplyUsed()/2>100){
				this->buildOrder->build(3,UnitTypes::Terran_Comsat_Station,68);
			}

			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,2)>=3){
				if (Broodwar->self()->minerals()>120){
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,65)<9){
						this->buildOrder->buildAdditional(1,UnitTypes::Terran_Factory,67);
					}					
				}			
			}
			//for machine shop ,produce more tanks
			if ((this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=6)){
				if (Broodwar->self()->supplyUsed()/2>100 && this->myInfor->CountUnitNum(UnitTypes::Terran_Machine_Shop,2)<3)
					this->buildOrder->build(3,UnitTypes::Terran_Machine_Shop,68);
			}
			if (Broodwar->self()->minerals()>70){
				if((this->myInfor->CountUnitNum(UnitTypes::Terran_Vulture,1)<30||this->buildOrder->getPlannedCount(UnitTypes::Terran_Vulture,65)<30)&& Broodwar->getFrameCount()%24*5==0)	
					this->buildOrder->buildAdditional(this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1),UnitTypes::Terran_Vulture,68);
				if((this->myInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,1)<34||this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,65)<34)&& Broodwar->getFrameCount()%24*7==0)	
					this->buildOrder->buildAdditional(this->myInfor->CountUnitNum(UnitTypes::Terran_Machine_Shop,1),UnitTypes::Terran_Siege_Tank_Tank_Mode,78);
			}

			//produce dropship
			if (this->mapDroppable && Broodwar->self()->supplyUsed()/2>60 && Broodwar->self()->deadUnitCount(UnitTypes::Terran_Dropship) < 3)
			{
				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Starport,2) < 1)
				{
					this->buildOrder->build(1,UnitTypes::Terran_Starport,100);
					this->buildOrder->build(1,UnitTypes::Terran_Control_Tower,98);
				}
				else if (this->myInfor->CountUnitNum(UnitTypes::Terran_Starport,1) >= 1)
				{
					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Dropship,2) < 1)
					{
						this->buildOrder->build(1,UnitTypes::Terran_Dropship,105);
					}
				}
			}
		}
		//stage 4-------------------------------------
		if (Broodwar->self()->supplyUsed()/2>160&&this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,2)>=4){
			//for machine shop ,produce more tanks
			if ((this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=6)){
				if (Broodwar->self()->supplyUsed()/2>100 && this->myInfor->CountUnitNum(UnitTypes::Terran_Machine_Shop,2)<4)
					this->buildOrder->build(4,UnitTypes::Terran_Machine_Shop,68);
			}

			//upgrade tech
			if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Charon_Boosters)<1)
				this->buildOrder->upgrade(1,UpgradeTypes::Charon_Boosters,68);
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Armory,2)<2){
				this->buildOrder->build(2,UnitTypes::Terran_Armory,71);
			}
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Armory,1)>0){
				if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Vehicle_Weapons)<1)
					this->buildOrder->upgrade(1,UpgradeTypes::Terran_Vehicle_Weapons,72);
				if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Vehicle_Plating)<1)
					this->buildOrder->upgrade(1,UpgradeTypes::Terran_Vehicle_Plating,72);

			}
			if (this->upgradeManager->getCompletedLevel(UpgradeTypes::Terran_Vehicle_Plating)>0
				&&this->upgradeManager->getCompletedLevel(UpgradeTypes::Terran_Vehicle_Weapons)>0){
					if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Vehicle_Weapons)<3)
						this->buildOrder->upgrade(3,UpgradeTypes::Terran_Vehicle_Weapons,72);
					if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Vehicle_Plating)<3)
						this->buildOrder->upgrade(3,UpgradeTypes::Terran_Vehicle_Plating,72);
			}

			//produce army
			if (Broodwar->self()->minerals()>100){
				//vulture
				if(this->myInfor->CountUnitNum(UnitTypes::Terran_Vulture,1)<30 && Broodwar->getFrameCount()%24*5==0){
					if(this->buildOrder->getPlannedCount(UnitTypes::Terran_Vulture,65)<30)					
						this->buildOrder->buildAdditional(this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1),UnitTypes::Terran_Vulture,70);
				}

				//goliath
				if(this->myInfor->CountUnitNum(UnitTypes::Terran_Armory,1)>0&&this->myInfor->CountUnitNum(UnitTypes::Terran_Goliath,1)<12 && Broodwar->getFrameCount()%24*8==0){
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Goliath,65)<12){
						this->buildOrder->buildAdditional(this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1),UnitTypes::Terran_Goliath,70);
					}
				}
				//tank
				if(this->myInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,1)<36 && Broodwar->getFrameCount()%24*9==0){
					if(this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,65)<36)
						this->buildOrder->buildAdditional(this->myInfor->CountUnitNum(UnitTypes::Terran_Machine_Shop,1),UnitTypes::Terran_Siege_Tank_Tank_Mode,71);
				}
				//Science_Vessel
				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Science_Vessel,2)<2 && Broodwar->self()->supplyUsed()>=170){
					if(this->buildOrder->getPlannedCount(UnitTypes::Terran_Science_Vessel,72)<2)
						this->buildOrder->build(2,UnitTypes::Terran_Science_Vessel,69);
				}
			}
			//for scanner
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Comsat_Station,2)<this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1)){
				this->buildOrder->build(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1),UnitTypes::Terran_Comsat_Station,73);
			}


			//if we have lots of money and don't expand
			if(Broodwar->getFrameCount()>=24*60*10 && Broodwar->self()->minerals()>3000)
			{
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center,100)<5)
					this->buildOrder->autoExpand(100,5);
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,65)<4)
					this->buildOrder->build(4,UnitTypes::Terran_Factory,73);
			}
			//more factories and expansion if we are rich
			if (Broodwar->self()->supplyUsed()/2>170 || (Broodwar->self()->minerals()>1300 && Broodwar->self()->supplyUsed()/2>150)){
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center,100)<6)
					this->buildOrder->autoExpand(100,6);
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,65)<10){
					this->buildOrder->build(10,UnitTypes::Terran_Factory,73);
				}
			}
		}
	}
	//******** From here is strategy for Terran*******************
	else{
		if (Broodwar->getFrameCount()%24*2==0){
			//gas control
			if (Broodwar->getFrameCount()%24*3==0 && this->myInfor->CountUnitNum(UnitTypes::Terran_Refinery,1)>0){
				if(Broodwar->self()->gas()-Broodwar->self()->minerals()>100 && Broodwar->self()->gas()>200 && Broodwar->self()->minerals()<500)
					this->worker->setWorkerPerGas(0);
				else{
					this->buildOrder->build(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1),UnitTypes::Terran_Refinery,80);
					if(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1)>=3)
						this->worker->setNeedGasLevel(3);
					else
						this->worker->setWorkerPerGas(3);
				}
			}
			//gas control end-------------------
			if (Broodwar->self()->supplyUsed()/2>100 && Broodwar->self()->minerals()>=2500 && Broodwar->self()->gas()<=200){
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center,100)<5)
					this->buildOrder->autoExpand(100,5);
			}
			//for exceptions
			if((Broodwar->getFrameCount()>24*60*5 && Broodwar->self()->supplyUsed()/2<40&&Broodwar->self()->minerals()>2000)){
				//expand
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center,100)<4)
					this->buildOrder->autoExpand(100,4);
				//factory
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,73)<7){
					this->buildOrder->build(7,UnitTypes::Terran_Factory,73);
				}
				//add on
				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=5&&this->buildOrder->getPlannedCount(UnitTypes::Terran_Machine_Shop,72)<3){
					this->buildOrder->build(3,UnitTypes::Terran_Machine_Shop,72);
				}
				//army
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Goliath,70)<35){
					this->buildOrder->build(35,UnitTypes::Terran_Goliath,70);
				}
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,70)<35){
					this->buildOrder->build(35,UnitTypes::Terran_Siege_Tank_Tank_Mode,70);
				}

			}
			//stage 1-------------------------------------------------fixed opening
			if (Broodwar->self()->supplyUsed()/2 >=7 && Broodwar->getFrameCount()<=24*60*5){
				TilePosition mapCenter = TilePosition(Broodwar->mapWidth()/2,Broodwar->mapHeight()/2);
				//TilePosition(this->choke->getSecondChoke()->getCenter())
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Barracks,2000)<2)
					this->buildOrder->build(2,UnitTypes::Terran_Barracks,2000,mapCenter);
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Marine,90)<8)
					this->buildOrder->build(8,UnitTypes::Terran_Marine,90);

				if (this->scout->enemyStartLocation && SelectAll()(isCompleted)(Marine).size()>=2 
					&& !this->enemyInfor->EnemyhasBuilt(UnitTypes::Terran_Vulture,1) 
					&& this->myInfor->myFightingValue().first > this->enemyInfor->enemyFightingValue().second &&
					this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)<2
					&& SelectAllEnemy()(isCompleted,canAttack).not(isWorker,isBuilding).size()<7){
						TilePosition eRegionCenter = TilePosition(BWTA::getRegion(this->scout->enemyStartLocation->getTilePosition())->getCenter());
						TilePosition eFirstChoke = TilePosition(this->choke->efirstChokepoint->getCenter());
						TilePosition rushBK = TilePosition((eRegionCenter.x()+eFirstChoke.x())/2,(eRegionCenter.y()+eFirstChoke.y())/2);

						int see = this->buildOrder->getPlannedCount(UnitTypes::Terran_Bunker);

						if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Bunker,95)<1)					
							this->buildOrder->build(1,UnitTypes::Terran_Bunker,95,rushBK);
				}
			}
			//if we have 2 marine(under training or already trained)
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Marine,2)>=2 && Broodwar->getFrameCount()%24*2==0 
				&& this->myInfor->CountUnitNum(UnitTypes::Terran_SCV,1)>=15){
					//expand 2nd base
					if ((Broodwar->enemy()->deadUnitCount(UnitTypes::Terran_SCV)+Broodwar->enemy()->deadUnitCount(UnitTypes::Terran_Marine))>=12
						&& Broodwar->getFrameCount()<=24*60*7+24*30)
						this->buildOrder->autoExpand(100,3);
					else
						this->buildOrder->autoExpand(100,2);

					this->buildOrder->build(1,UnitTypes::Terran_Refinery,99);

					//build a bunker			
					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Bunker,2)==0 && this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)>=2){
						std::set<Unit*> mBase = SelectAll()(Command_Center);
						for each(Unit* bc in mBase){
							if (bc->getTilePosition().getDistance(Broodwar->self()->getStartLocation())<8)
								continue;
							else{
								this->secondBaseTile = bc->getTilePosition();
								//BWTA::getNearestChokepoint(bc->getPosition())->getCenter().x()
								this->bunkerPosition= new TilePosition((bc->getTilePosition().x()+BWTA::getNearestChokepoint(bc->getPosition())->getCenter().x()/32)/2,(bc->getTilePosition().y()+BWTA::getNearestChokepoint(bc->getPosition())->getCenter().y()/32)/2);

							}
						}
						//if enemy has vulture, and we only have marine
						//or our fight value is  
						//or we don't have much advantages
						//then build a bunker

						if((this->enemyInfor->EnemyhasBuilt(UnitTypes::Terran_Vulture,1) && SelectAll()(isCompleted,canAttack).not(isWorker,Marine,isBuilding).size()<3)
							|| (this->myInfor->myFightingValue().first <= this->enemyInfor->enemyFightingValue().first)
							|| (this->enemyInfor->killedEnemyNum < 2*(Broodwar->self()->deadUnitCount(UnitTypes::Terran_Marine)+Broodwar->self()->deadUnitCount(UnitTypes::Terran_SCV)))){
								if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Bunker,98)<2)
									this->buildOrder->build(2,UnitTypes::Terran_Bunker,98,*this->bunkerPosition);
						}					
					}
					//build two more marine
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Marine,63)<4 && this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,2)>1){
						this->buildOrder->buildAdditional(1,UnitTypes::Terran_Marine,68);
					}				
			}
			//opening over, stage 2 begin--------------------------------------------------build some advanced buildings
			//first check if all necessary buildings for opening are constructed
			// && this->myInfor->CountUnitNum(UnitTypes::Terran_Bunker,1)>=1
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)>=2){
				//build two factories, one with machine shop
				this->buildOrder->build(2,UnitTypes::Terran_Factory,68);

				//once one factory is finished
				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=1){
					if(this->myInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,2)>=2)
						this->buildOrder->build(1,UnitTypes::Terran_Armory,71);
					if(this->myInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,2)>=4)
						this->buildOrder->build(1,UnitTypes::Terran_Academy,65);
					this->buildOrder->build(2,UnitTypes::Terran_Machine_Shop,68);
				}

				if (SelectAll()(isCompleted)(Siege_Tank).size()>=3 && Broodwar->self()->gas()>350 && this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,65)<4){
					this->buildOrder->build(5,UnitTypes::Terran_Factory,70);
				}
				//once we have armory
				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Armory,2)>0){
					if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Vehicle_Weapons)<1)
						this->buildOrder->upgrade(1,UpgradeTypes::Terran_Vehicle_Weapons,76);
				}

				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Armory,1)>0 && this->upgradeManager->getPlannedLevel(UpgradeTypes::Charon_Boosters)<1)
					this->buildOrder->upgrade(1,UpgradeTypes::Charon_Boosters,67);
				// If we have academy and population >42
				if (Broodwar->self()->supplyUsed()/2>=50 && this->myInfor->CountUnitNum(UnitTypes::Terran_Academy,1)>0)
					this->buildOrder->build(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1),UnitTypes::Terran_Comsat_Station,70);
				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,2)>=2)
					this->buildOrder->deleteItem(UnitTypes::Terran_Marine);
				//factoryTrainSet(3,0,0,66,0,0);
			}

			//stage 2 over, stage 3 begin------------------------build more factories,and train army
			//first check buildings for stage 2
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Machine_Shop,1)>0){
				if (!Broodwar->self()->hasResearched(TechTypes::Tank_Siege_Mode)&&!Broodwar->self()->isResearching(TechTypes::Tank_Siege_Mode)){
					this->buildOrder->research(TechTypes::Tank_Siege_Mode,69);
				}
				/*	if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Ion_Thrusters)<1 && Broodwar->self()->supplyUsed()/2>60)
				this->buildOrder->upgrade(1,UpgradeTypes::Ion_Thrusters,69);*/
				//train goliath
				if (Broodwar->self()->minerals()>100 && 
					this->myInfor->CountUnitNum(UnitTypes::Terran_Goliath,1)<9 && SelectAll()(isCompleted)(Siege_Tank).size()>=9
					&& Broodwar->getFrameCount()%24*5==0 && this->myInfor->CountUnitNum(UnitTypes::Terran_Armory,1)>0){
						this->buildOrder->build(9,UnitTypes::Terran_Goliath,69);
				}
				//train siege tank
				if (Broodwar->self()->minerals()>100 && 
					(this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,65)<25) 
					&& Broodwar->getFrameCount()%24*4==0){
						this->buildOrder->buildAdditional(this->myInfor->CountUnitNum(UnitTypes::Terran_Machine_Shop,1),UnitTypes::Terran_Siege_Tank_Tank_Mode,68);
				}

				//train vulture
				//if (Broodwar->self()->minerals()>60&&
				//	(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)<3 || this->buildOrder->getPlannedCount(UnitTypes::Terran_Vulture,65)<20) 
				//	&& Broodwar->getFrameCount()%24*4==0 && Broodwar->self()->supplyUsed()/2<=150){
				//		this->buildOrder->buildAdditional(this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1),UnitTypes::Terran_Vulture,68);
				//}

				//build more factories
				if (Broodwar->self()->minerals()>180 && this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,65)<4				
					&& SelectAll()(isCompleted)(Siege_Tank).size()>=5){
						//if (Broodwar->self()->minerals()>=320)
						//	this->buildOrder->buildAdditional(1,UnitTypes::Terran_Factory,70);
						//else
						this->buildOrder->buildAdditional(1,UnitTypes::Terran_Factory,68);
				}

				if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=4 && Broodwar->self()->minerals()>200){
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,65)<5)
						this->buildOrder->buildAdditional(1,UnitTypes::Terran_Factory,70);
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Machine_Shop,65)<3)
						this->buildOrder->buildAdditional(1,UnitTypes::Terran_Machine_Shop,70);

				}
				//if finish upgrading Terran_Vehicle_Weapons, then continue upgrade
				if (!SelectAll()(Armory)(isCompleted)(isUpgrading)(RemainingUpgradeTime,"<",24*60*2).empty()){
					if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Vehicle_Weapons)<3)
						this->buildOrder->upgrade(3,UpgradeTypes::Terran_Vehicle_Weapons,75);
				}
				//if we have advantages or too much money, then expand again
				if((Broodwar->self()->supplyUsed()/2>=100 && this->myInfor->myDeadArmy < this->enemyInfor->killedEnemyNum)
					|| (Broodwar->self()->minerals()>=1500 && Broodwar->self()->gas()<=300))
					this->buildOrder->autoExpand(100,5);					
			}

			//stage 3 over, stage 4 begin----------------- build more advanced building and military, upgrade
			if(Broodwar->self()->supplyUsed()/2>=120 &&
				this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,2)>=5 && 
				this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)>=3 &&
				Broodwar->self()->supplyUsed()/2<=160){
					//delete vulture and marine from build order list
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Marine,40)>0){
						this->buildOrder->deleteItem(UnitTypes::Terran_Marine,63);
						this->buildOrder->deleteItem(UnitTypes::Terran_Marine,68);
					}
					//build scanner
					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1)>=3 &&
						this->myInfor->CountUnitNum(UnitTypes::Terran_Comsat_Station,1)< this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1))
						this->buildOrder->build(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1),UnitTypes::Terran_Comsat_Station,80);
					//research siege mode
					if (!Broodwar->self()->hasResearched(TechTypes::Tank_Siege_Mode))
						this->buildOrder->research(TechTypes::Tank_Siege_Mode,70);
					// we need some tanks 
					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Machine_Shop,2)<3){
						this->buildOrder->build(3,UnitTypes::Terran_Machine_Shop,69);
					}	

					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)<9){
						this->buildOrder->build(9,UnitTypes::Terran_Factory,69);
					}


					if (Broodwar->self()->minerals()>100 && this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,65)<24
						&& Broodwar->getFrameCount()%24*5==0){
							this->buildOrder->buildAdditional(1,UnitTypes::Terran_Siege_Tank_Tank_Mode,69);
							//Broodwar->printf("%d",this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,65));
							//this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)
					}

					if (Broodwar->self()->minerals()>100 && Broodwar->getFrameCount()%24*5==0 && 
						(this->myInfor->CountUnitNum(UnitTypes::Terran_Goliath,1)<25)){
							this->buildOrder->build(25,UnitTypes::Terran_Goliath,68);
							//Broodwar->printf("%d",this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,65));
					}
					if (Broodwar->self()->minerals()>1500 && this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center,100)<5)
						this->buildOrder->autoExpand(100,5);
					//for produce battlecruiser , buid starport first
					if (Broodwar->self()->supplyUsed()/2>=130 && SelectAll()(isCompleted)(Siege_Tank).size()>=8
						&& this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1)>=2){
							if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Starport)<5){
								this->buildOrder->build(5,UnitTypes::Terran_Starport,110);							
							}
							if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Control_Tower)<5){
								this->buildOrder->build(5,UnitTypes::Terran_Control_Tower,108);
							}		
					}

					//produce battlecruiser
					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Starport,1)>=2){
						if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Battlecruiser)<30){
							this->buildOrder->build(30,UnitTypes::Terran_Battlecruiser,75);
						}
					}
					//for battlecruiser research and upgrde

					if (!SelectAll()(Physics_Lab)(isCompleted).empty()){
						// yamato gun research
						if(!Broodwar->self()->hasResearched(TechTypes::Yamato_Gun) || !Broodwar->self()->isResearching(TechTypes::Yamato_Gun))
							this->buildOrder->research(TechTypes::Yamato_Gun,106);
						if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Colossus_Reactor)<1 && Broodwar->self()->hasResearched(TechTypes::Yamato_Gun)){
							this->buildOrder->upgrade(1,UpgradeTypes::Colossus_Reactor,105);
						}
					}						

					//for upgrade						
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Armory)<3)
						this->buildOrder->build(3,UnitTypes::Terran_Armory,109);
					if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Ship_Weapons)<3){
						this->buildOrder->upgrade(3,UpgradeTypes::Terran_Ship_Weapons,107);
					}
					if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Ship_Plating)<3){
						this->buildOrder->upgrade(3,UpgradeTypes::Terran_Ship_Plating,107);
					}	
					// produce some tanks as an aid
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,80)<15){
						this->buildOrder->build(15,UnitTypes::Terran_Siege_Tank_Tank_Mode,80);
					}


			}
			//stage 4 over, final stage begin----------------- upgrade all technique that we need,more army, more expansion
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,2)>=2 && Broodwar->self()->supplyUsed()/2>160){
				//keep training army , the remains money is used for upgrade and research, expand
				//SelectAll(isTraining)(Factory).size()>0 &&SelectAll(isCompleted)(Factory).size()-SelectAll(isTraining)(Factory).size()<=1 &&
				if (Broodwar->self()->minerals()>150){
					if(this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,2)<8)
						this->buildOrder->build(8,UnitTypes::Terran_Factory,70);
					if(this->myInfor->CountUnitNum(UnitTypes::Terran_Armory,2)<2)
						this->buildOrder->build(2,UnitTypes::Terran_Armory,70);
					if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Vehicle_Weapons)<3)
						this->buildOrder->upgrade(3,UpgradeTypes::Terran_Vehicle_Weapons,70);
					if (this->upgradeManager->getPlannedLevel(UpgradeTypes::Terran_Vehicle_Weapons)<3)
						this->buildOrder->upgrade(3,UpgradeTypes::Terran_Vehicle_Plating,70);
					if(this->buildOrder->getPlannedCount(UnitTypes::Terran_Science_Vessel,70)<2)
						this->buildOrder->build(2,UnitTypes::Terran_Science_Vessel,70);
				}
				//expand more
				if (Broodwar->self()->supplyUsed()/2>170 || (Broodwar->self()->minerals()>1500 &&Broodwar->self()->supplyUsed()/2>140)){
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center,100)<5)
						this->buildOrder->autoExpand(100,5);

					if (Broodwar->self()->supplyUsed()/2>180 && Broodwar->self()->minerals()>2500){
						if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center,100)<7)
							this->buildOrder->autoExpand(100,7);				
					}					
				}




				//if reach 200 population, decrease priority of training amry 
				if (Broodwar->getFrameCount()%24*5 ==0 && Broodwar->self()->supplyUsed()/2<200 && Broodwar->self()->minerals()>100){
					/*					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,65)<30)
					this->buildOrder->buildAdditional(4,UnitTypes::Terran_Siege_Tank_Tank_Mode,68);
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,65)<50)
					this->buildOrder->buildAdditional(5,UnitTypes::Terran_Goliath,67);*/
					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Goliath,1)<36)
						this->buildOrder->build(36,UnitTypes::Terran_Goliath,75);
					if (this->myInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,1)<30)
						this->buildOrder->build(36,UnitTypes::Terran_Siege_Tank_Tank_Mode,75);
					if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Battlecruiser)<30)
						this->buildOrder->build(30,UnitTypes::Terran_Battlecruiser,75);

				}

				if (Broodwar->getFrameCount()%(24*20)==0){	
					this->buildOrder->build(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1),UnitTypes::Terran_Comsat_Station,80);
					this->buildOrder->autoExpand(100,7);				
				}

			}
		}	

	}
}

void GameFlow::balanceArmyCombination()
{
	//if (Broodwar->getFrameCount()%24*3==0)
	//	Broodwar->printf("tank:%d,vulture:%d,goliath:%d",tankPri,vulPri,goliathPri);
	if (Broodwar->getFrameCount()%24*5==0){
		int vultureNum = SelectAll()(isCompleted)(Vulture).size();
		int tankNum = SelectAll()(isCompleted)(Siege_Tank).size();
		if (vultureNum>=13 || tankNum >=6){
			if (vultureNum >= (int)(1.3*tankNum) ){
				if(vulPri>=tankPri){
					vulPri = tankPri - 1;
					this->buildOrder->adjustPriority(Vulture,vulPri - tankPri);
					this->buildOrder->build(3,UnitTypes::Terran_Machine_Shop,65);
				}		
				else
					return;
			}
			if (vultureNum < (int)(1.3*tankNum)){
				if (vulPri<tankPri && vulPri<63){				
					this->buildOrder->adjustPriority(Vulture,63-vulPri);
					vulPri = 63;
				}
				else if (vulPri<tankPri && vulPri>=63){
					vulPri = tankPri + 1 ;
					this->buildOrder->adjustPriority(Vulture,vulPri - tankPri);
				}
				else
					return;
			}
		}	
	}

}

void GameFlow::destroy()
{
	if (theGameFlow) delete theGameFlow;
}


void GameFlow::TTonFrame()
{
	if (Broodwar->getFrameCount()%24*2==0){
		//gas control
		if (Broodwar->getFrameCount()%24*3==0 && this->myInfor->CountUnitNum(UnitTypes::Terran_Refinery,1)>0){
			if(Broodwar->self()->gas()-Broodwar->self()->minerals()>100 && Broodwar->self()->gas()>200 && Broodwar->self()->minerals()<500)
				this->worker->setWorkerPerGas(0);
			else{
				this->buildOrder->build(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1),UnitTypes::Terran_Refinery,80);
				if(this->myInfor->CountUnitNum(UnitTypes::Terran_Command_Center,1)>=3)
					this->worker->setNeedGasLevel(3);
				else
					this->worker->setWorkerPerGas(3);
			}

		}

		//gas control end-------------------
		if (Broodwar->self()->supplyUsed()/2>100 && Broodwar->self()->minerals()>=2500 && Broodwar->self()->gas()<=200){
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center,100)<5)
				this->buildOrder->autoExpand(100,5);
		}
		//for exceptions
		if((Broodwar->getFrameCount()>24*60*5 && Broodwar->self()->supplyUsed()/2<40&&Broodwar->self()->minerals()>2000)){
			//expand
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Command_Center,100)<4)
				this->buildOrder->autoExpand(100,4);
			//factory
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,73)<7){
				this->buildOrder->build(7,UnitTypes::Terran_Factory,73);
			}
			//add on
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=5&&this->buildOrder->getPlannedCount(UnitTypes::Terran_Machine_Shop,72)<3){
				this->buildOrder->build(3,UnitTypes::Terran_Machine_Shop,72);
			}
			//army
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Goliath,70)<35){
				this->buildOrder->build(35,UnitTypes::Terran_Goliath,70);
			}
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,70)<35){
				this->buildOrder->build(35,UnitTypes::Terran_Siege_Tank_Tank_Mode,70);
			}

		}
		//stage 1-------------------------------------------------fixed opening
		if (Broodwar->self()->supplyUsed()/2 ==12){
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Barracks,100)<1)
				this->buildOrder->build(1,UnitTypes::Terran_Barracks,100);
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Refinery,99)<1&&this->myInfor->CountUnitNum(UnitTypes::Terran_Barracks,2)>0)
				this->buildOrder->build(1,UnitTypes::Terran_Refinery,99);
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Marine,63)<3)
				this->buildOrder->build(3,UnitTypes::Terran_Marine,63);
		}
		//if we have 2 marine(under training or already trained)
		if (this->myInfor->CountUnitNum(UnitTypes::Terran_Marine,2)>=2 && Broodwar->getFrameCount()%24*2==0){
			//expand 2nd base
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Factory,70)<2)
				this->buildOrder->build(2,UnitTypes::Terran_Factory,70);
			if (this->myInfor->CountUnitNum(UnitTypes::Terran_Factory,1)>=1){
				if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Machine_Shop,69)<2)
					this->buildOrder->build(2,UnitTypes::Terran_Machine_Shop,69);
			}

			//build two more marine
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Marine,63)<4){
				this->buildOrder->buildAdditional(1,UnitTypes::Terran_Marine,68);
			}				
		}
		if (this->myInfor->CountUnitNum(UnitTypes::Terran_Machine_Shop,1)>0){
			if (!Broodwar->self()->hasResearched(TechTypes::Tank_Siege_Mode)&&!Broodwar->self()->isResearching(TechTypes::Tank_Siege_Mode)){
				this->buildOrder->research(TechTypes::Tank_Siege_Mode,69);
			}
			if (this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,68)<5){
				this->buildOrder->build(5,UnitTypes::Terran_Siege_Tank_Tank_Mode,68);
				Broodwar->printf("%d",this->buildOrder->getPlannedCount(UnitTypes::Terran_Siege_Tank_Tank_Mode,68));		
			}
		}
	}
}