#include "Helper.h"

using namespace ICEStarCraft;
using namespace BWAPI;
using namespace BWTA;

ICEStarCraft::Helper::Helper(void)
{
}

ICEStarCraft::Helper::~Helper(void)
{
}

/*
Vector2 Helper::getFPC(set<Unit*> units)
{
	Position p;
	Position c = Helper::getCenter(units);

	double varX, varY, cov;
	double sumX2 = 0, sumY2 = 0, sumXY = 0;

	for each (Unit* u in units)
	{
		p = u->getPosition();
		sumX2 += 1.0 * p.x() * p.x();
		sumY2 += 1.0 * p.y() * p.y();
		sumXY += 1.0 * p.x() * p.y();
	}

	varX = sumX2 / units.size() - 1.0 * c.x() * c.x();
	varY = sumY2 / units.size() - 1.0 * c.y() * c.y();
	cov  = sumXY / units.size() - 1.0 * c.x() * c.y();

	return Vector2((varX - varY + sqrt((varX - varY) * (varX - varY) + 4 * cov * cov)) / (2 * cov),1);
}
*/

bool ICEStarCraft::Helper::isWalkable(int walkX, int walkY)
{
	return Broodwar->isWalkable(walkX, walkY) && Broodwar->getUnitsOnTile(walkX >> 2, walkY >> 2).empty();
}

bool ICEStarCraft::Helper::isWalkable(Position p)
{
	return isWalkable(p.x() >> 3, p.y() >> 3);
}

bool ICEStarCraft::Helper::isWalkable(TilePosition tp)
{
	for (int i = 0; i < 4; i++)
	{
		for (int j = 0; j < 4; j++)
		{
			if (!isWalkable(tp.x()*4 + i,tp.y()*4 + j))
				return false;
		}
	}
	return true;
}

bool ICEStarCraft::Helper::isWalkable(Position cur, Position des)
{
	if (!des.isValid() || !Broodwar->isWalkable(des.x() >> 3, des.y() >> 3) || !Broodwar->hasPath(cur, des))
	{
		return false;
	}

	Vector2 v = des - cur;
	Position tmp;
	for (int i = 1; i <= 4; i++)
	{
		tmp = v * 0.25 * i + cur;
		if (!tmp.isValid() || !Broodwar->isWalkable(tmp.x() >> 3, tmp.y() >> 3))
		{
			return false;
		}
	}

	return true;
}

bool ICEStarCraft::Helper::isConnected(TilePosition tp1, TilePosition tp2)
{
	if (!BWTA::isConnected(tp1,tp2))
	{
		return false;
	}

	vector<TilePosition> path = BWTA::getShortestPath(tp1,tp2);

	if (path.empty())
	{
		return false;
	}
	
	for each (TilePosition tp in path)
	{
		if (!Broodwar->getUnitsOnTile(tp.x(),tp.y()).empty())
		{
			return false;
		}
	}

	return true;
}

bool ICEStarCraft::Helper::isChokePointCenter(Position p)
{
	for each (BWTA::Chokepoint* cp in BWTA::getChokepoints())
	{
		if (cp->getCenter() == p)
			return true;
	}
	return false;
}

bool ICEStarCraft::Helper::isConnected(BWTA::Region* r1, BWTA::Region* r2)
{
	if (r1 == NULL || r2 == NULL)
	{
		return false;
	}
	
	for each (BWTA::Chokepoint* cp in BWTA::getChokepoints())
	{
		pair<BWTA::Region*,BWTA::Region*> p = cp->getRegions();
		if ((p.first == r1 && p.second == r2) || (p.first == r2 && p.second == r1))
		{	
			return true;
		}
	}
	return false;
}

BWTA::Chokepoint* ICEStarCraft::Helper::getChokePoint(BWTA::Region* r1, BWTA::Region* r2)
{
	for each (BWTA::Chokepoint* cp in BWTA::getChokepoints())
	{
		pair<BWTA::Region*,BWTA::Region*> p = cp->getRegions();
		if ((p.first == r1 && p.second == r2) || (p.first == r2 && p.second == r1))
		{	
			return cp;
		}
	}
	return NULL;
}

void ICEStarCraft::Helper::drawPolygonVertices(BWTA::Region* r)
{
	if (r == NULL)
	{
		Broodwar->printf("Invalid region");
		return;
	}

	Polygon p = r->getPolygon();
	set<Chokepoint*> cp = BWTA::getChokepoints();
	bool isChokePoint = false;

	for (Polygon::iterator i = p.begin(); i != p.end(); i++)
	{
		isChokePoint = false;
		for (set<Chokepoint*>::iterator c = cp.begin(); c != cp.end(); c++)
		{
			if ((*i) == (*c)->getCenter())
			{
				isChokePoint = true;
				break;
			}
		}	

		Broodwar->drawCircleMap((*i).x(),(*i).y(),2,Colors::Yellow,isChokePoint);
	}
}

void ICEStarCraft::Helper::drawRegionCenter(BWTA::Region* r)
{
	if (r == NULL)
	{
		Broodwar->printf("Invalid region");
		return;
	}

	Position center = r->getCenter();
	Broodwar->drawCircleMap(center.x(),center.y(),5,Colors::Red,true);
}