#include "InformationManager.h"
#include <math.h>
using namespace BWAPI;
using namespace BWTA;
using namespace std;

MyInforManager* myInforManager=NULL;


MyInforManager* MyInforManager::create()
{
	if (myInforManager) return myInforManager;
	else return myInforManager = new MyInforManager();
}


MyInforManager::MyInforManager()
{
	this->allmyUnits.clear();
	this->bmc= NULL;
	this->needScanNow = false;
	this->allMyFighter.clear();
	this->myDeadArmy = 0;
	this->myDeadWorker = 0;
}

void MyInforManager::setUsefulManagers(BaseManager* baseManager)
{
	this->bmc = baseManager;
}


int MyInforManager::getMyPopulation()
{
	return Broodwar->self()->supplyUsed()/2;
}

int MyInforManager::getMyBaseNum()
{
	return	(int)this->bmc->getBaseSet().size();
}
int MyInforManager::CountUnitNum(UnitType uType,int complete)
{
	int num = 0;
	this->allmyUnits = Broodwar->self()->getUnits();
	if (complete==1){
		for each(Unit* unit in this->allmyUnits){
			if(unit->getType()==uType && unit->isCompleted()){
				num++;
			}
		}
	}
	else if(complete==0){
		for each(Unit* unit in this->allmyUnits){
			if(unit->getType()==uType && !unit->isCompleted()){
				num++;
			}
		}
	}
	else{
		for each(Unit* unit in this->allmyUnits){
			if(unit->getType()==uType){
				num++;
			}
		}
	}
	return num;
}

void MyInforManager::myInfoOnFrame()
{
	if (Broodwar->getFrameCount()%24==0){
		//myFightingValue();
		//calculate dead army
		int deadMarine = Broodwar->self()->deadUnitCount(UnitTypes::Terran_Marine);
		int deadTank = Broodwar->self()->deadUnitCount(UnitTypes::Terran_Siege_Tank_Siege_Mode);
		int deadGoliath = Broodwar->self()->deadUnitCount(UnitTypes::Terran_Goliath);
		int deadVulture = Broodwar->self()->deadUnitCount(UnitTypes::Terran_Vulture);
		int deadBattlecruiser = Broodwar->self()->deadUnitCount(UnitTypes::Terran_Battlecruiser);
			
		if (Broodwar->self()->supplyUsed()/2 < 65){
			this->myDeadArmy = deadMarine+deadTank+deadVulture+deadGoliath;
		}
		else
			this->myDeadArmy = deadTank+deadVulture+deadGoliath+deadBattlecruiser*2;

		this->myDeadWorker = Broodwar->self()->deadUnitCount(UnitTypes::Terran_SCV);
	}

	//drawing deadArmy
#ifdef _BATTLE_DEBUG
	Broodwar->drawTextScreen(0,40,"My_Dead_Army: %d",this->myDeadArmy);
#endif
	
}
int MyInforManager::getMyArmyNum()
{
	int fighterNum = 0;
	std::set<Unit*> mUnits = Broodwar->self()->getUnits();
	for (std::set<Unit*>::iterator i = mUnits.begin(); i != mUnits.end(); i++){
		Unit* u = *i;
		if(u->getType().isBuilding()|| u->getType().isWorker() || !u->isCompleted()||!u->getType().canAttack())
			continue;
		else
			fighterNum++;
	}
	//fighterNum = (int)SelectAll()(isCompleted)(Vulture,Siege_Tank,Goliath).size();
	return fighterNum;
}

void MyInforManager::destroy()
{
	if (myInforManager) delete myInforManager;
}

/****************************************************/
/**************FOR ENEMY INFORMATION*****************/
/****************************************************/

EnemyInforManager* enemyInforManager=NULL;

EnemyInforManager* EnemyInforManager::create()
{
	if (enemyInforManager) return enemyInforManager;
	else return enemyInforManager = new EnemyInforManager();
}

EnemyInforManager::EnemyInforManager()
{
	this->enemyDeadWorker = 0;
	this->killedEnemyNum = 0;
	this->eUnitTypeToTimeMap.clear();
	this->eUnitToUintTypeMap.clear();
	this->allenemyFighter.clear();
	this->eBuildingPositionMap.clear();
	this->enemyBaseMap.clear();
	this->needScanNow =false;
	this->showTypeToTime=false;
	this->showUnitToType=false;
	this->showBuildingToPosition=false;
	this->showBaseToData=false;
	this->drRangeUpgradeFlag = false;
	this->mInfor = MyInforManager::create();
	this->scm = ScoutManager::create();
	this->eMainBaseCheck = false;
}
EnemyInforManager::eBaseData::eBaseData()
{
	this->checkFinish=false;
	this->startBuildTime = 0;
	this->currentTime=0;
	this->finishTime=0;
	this->ProgressRate=0;
	this->tPosition = TilePositions::None;
	this->position = Positions::None;
	this->isStartBase = false;
	this->isMainBase = false;
	uType = UnitTypes::Unknown;
}
bool EnemyInforManager::EnemyhasBuilt(UnitType uType,int n)
{
	for (std::map<UnitType,std::pair<int,bool>>::iterator i=this->eUnitTypeToTimeMap.begin(); i!= this->eUnitTypeToTimeMap.end();i++){
		if (uType==i->first){
			//0 for not completed unit
			if (n==0){
				if (i->second.second)
					return false;
				else
					return true;
			}
			//1 for completed unit
			if (n==1){
				if (i->second.second)
					return true;
				else
					return false;
			}
			//other number for completed and uncompleted
			if (n>1)
				return true;
		}
	}
//if can not find 
	return false;
}
void EnemyInforManager::onUnitDiscover(Unit* u)
{
	if (!u || (u && !u->exists()))
		return;

	if(Broodwar->self()->isEnemy(u->getPlayer())){
		UnitType thisType=u->getType();
		if (thisType == UnitTypes::Protoss_Cybernetics_Core && u->isResearching())
			this->drRangeUpgradeFlag = true;
		//collect enemy unit type and first seen time
		if(this->eUnitTypeToTimeMap.find(thisType)==this->eUnitTypeToTimeMap.end()){
			if (u->isCompleted())
				this->eUnitTypeToTimeMap[thisType]=std::make_pair(Broodwar->getFrameCount(),true);
			else
				this->eUnitTypeToTimeMap[thisType]=std::make_pair(Broodwar->getFrameCount(),false);
		}
			
		if(this->eUnitTypeToTimeMap.find(thisType)!=this->eUnitTypeToTimeMap.end() && this->eUnitTypeToTimeMap[u->getType()].first==0)
			this->eUnitTypeToTimeMap[thisType]=std::make_pair(Broodwar->getFrameCount(),true);

		unitTypeInfer(u);

		//collect all enemy units and their types 
		if(this->eUnitToUintTypeMap.find(u)==this->eUnitToUintTypeMap.end())
			this->eUnitToUintTypeMap[u]=u->getType();

		//collect all enemy units and their positions
		if(this->eBuildingPositionMap.find(u)==this->eBuildingPositionMap.end()&&u->getType().isBuilding())
			this->eBuildingPositionMap[u]=make_pair(u->getType(),u->getPosition());


		//collect all enemy resource depot
		if (u->getType().isResourceDepot()){
			if(this->enemyBaseMap.find(u)==this->enemyBaseMap.end()){
				//if resource depot already finished when find it
				if(u->isCompleted()){
					this->enemyBaseMap[u].position = u->getPosition();
					this->enemyBaseMap[u].checkFinish=true;
					this->enemyBaseMap[u].uType=u->getType();
					this->enemyBaseMap[u].currentTime=Broodwar->getFrameCount();
					this->enemyBaseMap[u].tPosition=u->getTilePosition();
					this->enemyBaseMap[u].ProgressRate = 100;

					std::set<TilePosition> startTileLocations;
					for each(BWTA::BaseLocation* bl in BWTA::getStartLocations()){
						startTileLocations.insert(bl->getTilePosition());
					}

					if(startTileLocations.find(u->getTilePosition())!=startTileLocations.end())
						this->enemyBaseMap[u].isStartBase = true;
					else
						this->enemyBaseMap[u].isStartBase = false;

					//if game time still early
					if(Broodwar->getFrameCount()<=24*60*4){
						for each(BaseLocation* bl in BWTA::getStartLocations()){
							if(bl->getTilePosition()==u->getTilePosition()){
								this->enemyBaseMap[u].isMainBase = true;
								break;
							}
						}
						if(this->enemyBaseMap[u].isMainBase){
							this->enemyBaseMap[u].finishTime = -1;
							this->enemyBaseMap[u].startBuildTime = -1;
						}
						else{
							this->enemyBaseMap[u].finishTime = Broodwar->getFrameCount()/24/60;
							this->enemyBaseMap[u].startBuildTime = Broodwar->getFrameCount()-u->getType().buildTime()/24/60;
						}					

					}
					//else we don't know when this depot being built
					else{
						this->enemyBaseMap[u].finishTime = -1;
						this->enemyBaseMap[u].startBuildTime = -1;

					}
				}
				//if resource hasn't finish yet
				else if(!u->isCompleted()){
					this->enemyBaseMap[u].checkFinish = false;
					this->enemyBaseMap[u].uType = u->getType();
					this->enemyBaseMap[u].currentTime=Broodwar->getFrameCount();
					this->enemyBaseMap[u].tPosition=u->getTilePosition();
					this->enemyBaseMap[u].position=u->getPosition();
					this->enemyBaseMap[u].ProgressRate = ((double)u->getHitPoints()/(double)u->getType().maxHitPoints())*100;
					int see1 = u->getHitPoints();
					int see2 = u->getType().maxHitPoints();
					double see3 = ((double)u->getHitPoints()/(double)u->getType().maxHitPoints())*100;
					//Broodwar->printf("hitpoint: %d,Max: %d, result:%f",see1,see2,see3);
					this->enemyBaseMap[u].finishTime = u->getRemainingBuildTime()+Broodwar->getFrameCount();
					this->enemyBaseMap[u].startBuildTime = Broodwar->getFrameCount()-(u->getType().buildTime()-u->getRemainingBuildTime());
				}
			}				
		}
		//add to allenemyFight
		//!u->getType().isFlyer() &&
		if (u->getType()!= UnitTypes::Zerg_Scourge && u->getType()!=UnitTypes::Protoss_Interceptor && u->getType()!=UnitTypes::Terran_Vulture_Spider_Mine && !u->getType().isWorker() && u->getType().canAttack() && !u->getType().isBuilding() && u->exists() && u->isCompleted())
			allenemyFighter[u]=u->getType();
		else if (u->getType()==UnitTypes::Zerg_Sunken_Colony || u->getType()==UnitTypes::Protoss_Photon_Cannon){
			allenemyFighter[u]=u->getType();
		}
	}
}

void EnemyInforManager::onUnitDestroy(Unit* u)
{
	//count for total population of killed enemy 
	if (Broodwar->self()->isEnemy(u->getPlayer())){
		if(!u->getType().isBuilding())
			this->killedEnemyNum ++;

		if(u->getType().isWorker())
			this->enemyDeadWorker ++;
		//delete unit from Maps
		this->eUnitToUintTypeMap.erase(u);

		this->eBuildingPositionMap.erase(u);

		if(CountEunitNum(u->getType())==0)
			this->eUnitTypeToTimeMap.erase(u->getType());
		this->enemyBaseMap.erase(u);
		this->allenemyFighter.erase(u);
	}
}


void EnemyInforManager::unitTypeInfer(Unit* u)
{
	map<UnitType,int> tempMap;
	tempMap.clear();
	tempMap = u->getType().requiredUnits();
	for(map<UnitType,int>::const_iterator i=tempMap.begin();i!=tempMap.end();i++){
		if(this->eUnitTypeToTimeMap.find(i->first)==this->eUnitTypeToTimeMap.end())
			this->eUnitTypeToTimeMap[i->first] = std::make_pair(Broodwar->getFrameCount(),true);
	}
}

int EnemyInforManager::CountEunitNum(UnitType uType)
{
	int num = 0;
	for (map<Unit*,UnitType>::const_iterator i = this->eUnitToUintTypeMap.begin(); i!= this->eUnitToUintTypeMap.end();i++){
		if(i->second==uType)
			num++;
	}
	return num;
}

void EnemyInforManager::onUnitMorph(BWAPI::Unit* u)
{
	if (Broodwar->self()->isEnemy(u->getPlayer())){
		if (this->eBuildingPositionMap.find(u)!=this->eBuildingPositionMap.end()){
			this->eBuildingPositionMap.erase(u);
		}
		//this->enemyBaseMap.erase(u);
	}

}

map<Unit*,EnemyInforManager::eBaseData> EnemyInforManager::getEnemyBaseMap()
{
	return this->enemyBaseMap;
}

pair<int,Position> EnemyInforManager::getLastSeenEnemyArmy(UnitGroup ug)
{
	if (ug.size()<8)
		return make_pair(-1,Positions::None);	

	else		
		return make_pair(Broodwar->getFrameCount(),ug.getCenter());	
}

int  EnemyInforManager::getEnemyBaseNum()
{
	return (int)this->enemyBaseMap.size();
}

int  EnemyInforManager::getKilledEnemyNum()
{
	return this->killedEnemyNum;
}

int EnemyInforManager::timeToDefendMutalisk(Unit* u)
{
	if (Broodwar->self()->isEnemy(u->getPlayer())){
		if (u->getType()==UnitTypes::Zerg_Mutalisk){
			return Broodwar->getFrameCount();
		}
		else if (u->getType()==UnitTypes::Zerg_Spire){
			if (u->isCompleted()){
				return Broodwar->getFrameCount();
			}
			else{
				int executeTime = 0;
				if(hasUnitType(UnitTypes::Terran_Engineering_Bay,Broodwar->self())){
					executeTime=Broodwar->getFrameCount()+u->getRemainingBuildTime()+UnitTypes::Zerg_Mutalisk.buildTime()-24*15;
					return executeTime;
				}
				else{
					executeTime=Broodwar->getFrameCount()+u->getRemainingBuildTime()+UnitTypes::Zerg_Mutalisk.buildTime()-UnitTypes::Terran_Engineering_Bay.buildTime()-24*15;
					return executeTime;
				}
			}
		}
	}
	return Broodwar->getFrameCount();
}


void EnemyInforManager::showTypeToTimeMap()
{
	if(this->showTypeToTime){	
		Broodwar->drawTextScreen(460,20,"\x0F| UnitType - DiscoverTime |");
		int uline = 1;
		for(std::map<UnitType,std::pair<int,bool>>::iterator i = this->eUnitTypeToTimeMap.begin();i != this->eUnitTypeToTimeMap.end();i++){
			Broodwar->drawTextScreen(460,20+16*uline,"\x0F| %s - %d |",i->first.c_str(),i->second.first);
			uline++;
		}
	}	
}

void EnemyInforManager::showUnitToTypeMap()
{
	if(this->showUnitToType){	
		Broodwar->drawTextScreen(450,20,"\x08| UnitType - Number |");
		int uline = 1;
		for(std::map<UnitType,std::pair<int,bool>>::const_iterator i = this->eUnitTypeToTimeMap.begin();i != this->eUnitTypeToTimeMap.end();i++){
			Broodwar->drawTextScreen(450,20+16*uline,"\x11| %s - %d |",i->first.c_str(),CountEunitNum(i->first));
			uline++;
		}
	}	
}

void EnemyInforManager::showBuildingToPositionMap()
{
	if (this->showBuildingToPosition){
		Broodwar->drawTextScreen(430,20,"\x08| Building - Position |");
		int uline = 1;
		for(std::map<Unit*,std::pair<UnitType,Position>>::const_iterator i = this->eBuildingPositionMap.begin();i != this->eBuildingPositionMap.end();i++){
			Broodwar->drawTextScreen(430,20+16*uline,"\x3| %s - (%d,%d) |",i->second.first.c_str(),i->second.second.x(),i->second.second.y());
			uline++;
		}
	}
}


void EnemyInforManager::showBaseToDataMap()
{
	if(this->showBaseToData){		
		Broodwar->drawTextScreen(100,10,"\x08| BaseType--isStartLocation--Position--Progress|");
		int uline = 1;
		for(std::map<Unit*,eBaseData>::const_iterator i = this->enemyBaseMap.begin();i != this->enemyBaseMap.end();i++){
			Broodwar->drawTextScreen(100,10+16*uline,"\x19| %s--%d--(%d,%d)--%2lf%% | ",i->second.uType.c_str(),i->second.isMainBase,i->second.tPosition.x(),i->second.tPosition.y(),i->second.ProgressRate);
			uline++;
		}		
	}

}
/////////public//////////
bool hasUnitType(UnitType uType,Player* player)
{
	set<Unit*> myUnits = Broodwar->self()->getUnits();
	UnitGroup enemyUnits = SelectAllEnemy()(isVisible);
	if (player == Broodwar->self()){
		for each(Unit* unit in myUnits){
			if(unit->getType()==uType){
				return true;
			}
		}
	}
	else if (player == Broodwar->enemy()){
		for each(Unit* unit in enemyUnits){
			if(unit->getType()==uType){
				return true;
			}
		}
	}

	return false;
}

void EnemyInforManager::onFrame()
{
	if (Broodwar->getFrameCount()%24==0){
		// delete destroyed enemy buildings on frame
		for(map<Unit*,std::pair<UnitType,Position>>::iterator i = eBuildingPositionMap.begin(); i != eBuildingPositionMap.end();){
			UnitGroup myUnit = SelectAll()(isCompleted).not(Vulture_Spider_Mine).inRadius(32*4,i->second.second);
			UnitGroup eBuild = SelectAllEnemy()(isBuilding,isAddon).inRadius(32*4,i->second.second);
			if (myUnit.size()>0 && (!i->first->exists() || eBuild.size()<1)){
				i = eBuildingPositionMap.erase(i);
				continue;
			}
			else{
				i++;
				continue;
			}
		}
		// for protoss dragoon rush confirm
		UnitGroup researchingCC = SelectAllEnemy()(isVisible,isBuilding,isCompleted,isResearching)(Cybernetics_Core);
		if (!researchingCC.empty())
			drRangeUpgradeFlag = true;
		
	
		//calculate enmey fight value
		//enemyFightingValue();
		//distinguish enemy mainbase and expansion 
		enemyMainBaseConfirm();

		//update enemy uncompleted units info
		for (std::map<UnitType,std::pair<int,bool>>::iterator i=this->eUnitTypeToTimeMap.begin(); i!= this->eUnitTypeToTimeMap.end();i++){
			if (i->second.second==false){
				if (Broodwar->getFrameCount()>=i->second.first+24*30)
					i->second.second = true;
				else
					continue;
			}	
			else
				continue;
		}
	}
	//drawing enemy dead units
#ifdef _BATTLE_DEBUG
	Broodwar->drawTextScreen(0,20,"Killed_Enemy_Total: %d",this->killedEnemyNum);
	Broodwar->drawTextScreen(0,30,"Killed_Enemy_Worker: %d",this->enemyDeadWorker);
#endif

}

void EnemyInforManager::destroy()
{
	if (enemyInforManager) delete enemyInforManager;
}

std::pair<double,double> EnemyInforManager::enemyFightingValue()
{
	//enemy movable army
	double eFV = 0;
	//enemy defend value
	double eDV = 0;
	double towerWeight=0;
	double flyerWeight=0;
	//for defend tower weight
	if (this->mInfor->CountUnitNum(UnitTypes::Terran_Siege_Tank_Tank_Mode,1)>0&&Broodwar->self()->hasResearched(TechTypes::Tank_Siege_Mode))
		towerWeight=0.3;
	else
		towerWeight=0.6;

	//for defend tower weight
	if (Broodwar->self()->getUpgradeLevel(UpgradeTypes::Charon_Boosters)>0){
		flyerWeight = pow(0.9,this->mInfor->CountUnitNum(UnitTypes::Terran_Goliath,1));	
	}
	else
		flyerWeight=1;

	//calculate enemy defend value
	for(std::map<Unit*,UnitType>::iterator i=this->allenemyFighter.begin(); i!= this->allenemyFighter.end();i++){
		//if the unit type is defend tower, then fighting value * weight
		if (i->second.groundWeapon()==WeaponTypes::None || i->second.groundWeapon().damageCooldown()==0){
			if (i->second==UnitTypes::Protoss_Carrier){
				eDV+=UnitTypes::Protoss_Interceptor.groundWeapon().damageAmount()/UnitTypes::Protoss_Interceptor.groundWeapon().damageCooldown()*(i->second.maxHitPoints()+i->second.maxShields()-1)*flyerWeight;
			}
			else
				continue;
		}
		else if (i->second==UnitTypes::Zerg_Sunken_Colony || i->second==UnitTypes::Protoss_Photon_Cannon)
			eDV+=(i->second.groundWeapon().damageAmount()*1.0/i->second.groundWeapon().damageCooldown()*(i->second.maxHitPoints()+i->second.maxShields()-1))*towerWeight;
		else if (i->second.groundWeapon().damageAmount()<2||!i->second.canAttack())
			continue;
		else if (i->second.isFlyer()&&i->second.groundWeapon()!=WeaponTypes::None)
			eDV+=i->second.groundWeapon().damageAmount()*1.0/i->second.groundWeapon().damageCooldown()*(i->second.maxHitPoints()+i->second.maxShields()-1)*flyerWeight;
			//eFV+=UnitTypes::Zerg_Sunken_Colony.groundWeapon().damageAmount()*1.0/UnitTypes::Zerg_Sunken_Colony.groundWeapon().damageCooldown()*(UnitTypes::Zerg_Sunken_Colony.maxHitPoints()-1)*towerWeight;
		else
			eDV+=i->second.groundWeapon().damageAmount()*1.0/i->second.groundWeapon().damageCooldown()*(i->second.maxHitPoints()+i->second.maxShields()-1);
	}

	//calculate enemy fighting value
	for(std::map<Unit*,UnitType>::iterator i=this->allenemyFighter.begin(); i!= this->allenemyFighter.end();i++){
		//if the unit type is defend tower, then fighting value * weight
		if (i->second==UnitTypes::Zerg_Sunken_Colony || i->second==UnitTypes::Protoss_Photon_Cannon)
			continue;
		else if (i->second.groundWeapon()==WeaponTypes::None || i->second.groundWeapon().damageCooldown()==0){
			if (i->second==UnitTypes::Protoss_Carrier){
				eFV+=UnitTypes::Protoss_Interceptor.groundWeapon().damageAmount()/UnitTypes::Protoss_Interceptor.groundWeapon().damageCooldown()*(i->second.maxHitPoints()+i->second.maxShields()-1)*flyerWeight;
			}
			else
				continue;
		}		
		else if (i->second.isFlyer()&&i->second.groundWeapon()!=WeaponTypes::None)
			eFV+=i->second.groundWeapon().damageAmount()*1.0/i->second.groundWeapon().damageCooldown()*(i->second.maxHitPoints()+i->second.maxShields()-1)*flyerWeight;
		else
			eFV+=i->second.groundWeapon().damageAmount()*1.0/i->second.groundWeapon().damageCooldown()*(i->second.maxHitPoints()+i->second.maxShields()-1);
	}
	if (this->killedEnemyNum>0)
		return std::make_pair(eFV/killedEnemyNum,eDV/killedEnemyNum);	
	else
		return std::make_pair(eFV,eDV);	
}

std::pair<double,double> MyInforManager::myFightingValue()
{
	if (!this->allMyFighter.empty()){
		UnitGroup bunkerGroup = SelectAll()(isCompleted)(Bunker);
		double mFV = 0;
		double mDV = 0;
		for each(Unit* u in this->allMyFighter){
			int atkBonus =u->getType().groundWeapon().damageFactor()*Broodwar->self()->getUpgradeLevel(u->getType().groundWeapon().upgradeType());
			int defBonus = Broodwar->self()->getUpgradeLevel(u->getType().armorUpgrade());
			if(!u->getType().canAttack()||!u->isCompleted())
				continue;
			else if (u->getType()==UnitTypes::Terran_Vulture_Spider_Mine || u->isLoaded())
				continue;
			else{
				mFV+=(u->getType().groundWeapon().damageAmount()+atkBonus)*1.0/u->getType().groundWeapon().damageCooldown()*(u->getHitPoints()+u->getShields()-1+defBonus);
				mDV+=(u->getType().groundWeapon().damageAmount()+atkBonus)*1.0/u->getType().groundWeapon().damageCooldown()*(u->getHitPoints()+u->getShields()-1+defBonus);
			}				
		}
		for each(Unit* u in bunkerGroup){
			//we only produce marine into bunker
			mDV+=u->getLoadedUnits().size()*6.0/UnitTypes::Terran_Marine.groundWeapon().damageCooldown()*(u->getHitPoints()-1);		
		}
		if(this->myDeadArmy+this->myDeadWorker>0)
			return std::make_pair(mFV/((double)1.3*(this->myDeadArmy+this->myDeadWorker)),mDV/((double)1.3*(this->myDeadArmy+this->myDeadWorker)));
		else
			return std::make_pair(mFV,mDV);
	}
	else
		return std::make_pair(0,0);
}

void MyInforManager::onUnitDestroy(Unit* u)
{
	allmyUnits.erase(u);
	this->allMyFighter.erase(u);
}

void MyInforManager::onUnitDiscover(Unit* u)
{
	if (u->getPlayer()==Broodwar->self()){
		if (u->getType().canAttack()&& !u->getType().isBuilding() && !u->getType().isWorker() && u->getType()!=UnitTypes::Terran_Vulture_Spider_Mine)
			this->allMyFighter.insert(u);
	}
}

void EnemyInforManager::enemyMainBaseConfirm()
{
	if (this->scm->enemyStartLocation){
		if(this->eMainBaseCheck) return;

		for(std::map<Unit*,eBaseData>::iterator i = this->enemyBaseMap.begin();i != this->enemyBaseMap.end();i++){
			if (i->second.tPosition==this->scm->enemyStartLocation->getTilePosition()){
				i->second.isMainBase = true;
				this->eMainBaseCheck =true;
			}				
			else{
				i->second.isMainBase = false;
				continue;
			}
		}
	}
}