#include "TerrainManager.h"
//#include "Vector2.h"

using namespace BWAPI;
using namespace BWTA;
using namespace ICEStarCraft;
using namespace std;

ChokepointManager* theChokePointManager = NULL;

ChokepointManager* ChokepointManager::create()
{
	if (theChokePointManager) return theChokePointManager;
	else return theChokePointManager = new ChokepointManager();
}


ChokepointManager::ChokepointManager()
{
	this->mfirstChokepoint = BWTA::getNearestChokepoint(Broodwar->self()->getStartLocation());
	this->msecondChokepoint = NULL;
	this->mthirdChokepoint = NULL;
	this->BTPostion.clear();
	this->earlyBestPoint = BWAPI::Positions::None;
	this->lateBestPoint = BWAPI::Positions::None;
	this->CCPosition = BWTA::getStartLocation(Broodwar->self())->getPosition();
	this->CCTilePosition = Broodwar->self()->getStartLocation();
	this->SiegePostionSet.clear();
	this->bestSiegeTile=BWAPI::TilePositions::None;
	this->efirstChokepoint=NULL;
	this->esecondChokepoint=NULL;
	this->ethirdChokepoint=NULL;
	this->eBaseCenter=BWAPI::Positions::None;
	this->finishEnemyChoke=false;
	this->scm =NULL;
	this->enemyNearestExpansion=NULL;
	this->mBestSetPoint=Positions::None;
	this->mBestSetPoint2=Positions::None;
	this->mBestGatherPoint=Positions::None;
	ckpSet.clear();
	rgSet.clear();
	regionVertices.clear();
	this->dropReg = getDroppablePosition();
}

void ChokepointManager::setUsefulChokepoint()
{

	BWTA::Region* tryR = BWTA::getRegion(Broodwar->self()->getStartLocation());
	ckpSet = tryR->getChokepoints();
	for each (Chokepoint *c in ckpSet){
		if (c->getRegions().first != tryR)
			rgSet.insert(c->getRegions().first);
		else 
			rgSet.insert(c->getRegions().second);
	}
	//find second choke point
	std::set<BWTA::Chokepoint*>chokePointSet = BWTA::getChokepoints();
	double tempDis = 99999;
	for each(BWTA::Chokepoint* cp in chokePointSet){
		if(cp == this->mfirstChokepoint)
			continue;		
		if(tempDis == 99999 || cp->getCenter().getDistance(this->mfirstChokepoint->getCenter()) < tempDis){
			tempDis = cp->getCenter().getDistance(this->mfirstChokepoint->getCenter());
			this->msecondChokepoint = cp;
		}
	}

	//find third chokepoint
	TilePosition* mapTileCenter = new TilePosition(BWAPI::Broodwar->mapHeight()/2,BWAPI::Broodwar->mapWidth()/2);
	Position* mapCenter = new Position((mapTileCenter->x()*32),(mapTileCenter->y()*32));
	double tempWidth =0;
	for each(BWTA::Chokepoint* cp in chokePointSet){			
		if(cp == this->mfirstChokepoint || (cp == this->msecondChokepoint && this->msecondChokepoint != NULL))
			continue;
		else if (cp->getCenter().getApproxDistance(this->msecondChokepoint->getCenter())<600){
			if(cp->getWidth()>tempWidth){
				tempWidth = cp->getWidth();
				this->mthirdChokepoint = cp;
			}		
		}	
		else if(this->mthirdChokepoint == NULL) this->mthirdChokepoint = this->msecondChokepoint;
	}
	//find 4th setPoint
	std::set<Position> pset;
	pset.clear();
	Position mapcenter = Position(Broodwar->mapWidth()/2*32,Broodwar->mapHeight()/2*32);
	for (int x=1;x<Broodwar->mapWidth();x++){
		for(int y=1;y<Broodwar->mapHeight();y++){
			Position newposition = Position(x*32,y*32);
			if(newposition.getApproxDistance(this->mthirdChokepoint->getCenter())>32*13
				&&newposition.getApproxDistance(this->mthirdChokepoint->getCenter())<32*15
				&&newposition.getApproxDistance(this->CCPosition)>32*32
				&&newposition.getApproxDistance(mapcenter)<mapcenter.getApproxDistance(this->mthirdChokepoint->getCenter())
				&&isTileWalkable((TilePosition)newposition)){
					pset.insert(newposition);
			}		
		}
	}
	int sdis=0;

	for each(Position p in pset){
		if((sdis==0 || p.getApproxDistance(this->mthirdChokepoint->getCenter())<sdis)&&isSurroundingWalkable(p.x(),p.y())){
			sdis = p.getApproxDistance(this->mthirdChokepoint->getCenter());
			this->mBestSetPoint = p;
		}
	}

	/*****************  Best Set Position**********************/
	bestSetPoint();
	/*****************  TilePositions for Turret**********************/
	BWTA::Region* mRegion = BWTA::getStartLocation(Broodwar->self())->getRegion();
	TilePosition fP = Broodwar->self()->getStartLocation();
	//TilePosition refer = (TilePosition) mRegion->getPolygon().getNearestPoint(BWTA::getNearestUnwalkablePosition(BWTA::getStartLocation(Broodwar->self())->getPosition()));
	TilePosition RegionCenter =(TilePosition) mRegion->getCenter();
	TilePosition sC = (TilePosition)msecondChokepoint->getCenter();
	TilePosition* nextBT = new TilePosition(0,0);
	TilePosition refer2 = Broodwar->self()->getStartLocation();
	this->BTPostion.clear();

	this->BTPostion.insert(fP);
	
	for (int x=0;x<=Broodwar->mapHeight();x++){
		if(refer2 != Broodwar->self()->getStartLocation())
			break;
		for(int y=0;y<=Broodwar->mapWidth();y++){
			TilePosition* firstBT = new TilePosition(x,y);
			//&&(int)firstBT->getDistance((TilePosition)mRegion->getCenter())>13
			if(!Broodwar->isWalkable(x,y)&&(int)firstBT->getDistance((TilePosition)mRegion->getCenter())<18 && (int)firstBT->getDistance(fP)>15){
				//left top
				if(fP.x()<Broodwar->mapWidth()/3 && fP.y()<Broodwar->mapHeight()/3
					&&(firstBT->x()<fP.x()*2 || (firstBT->y()<fP.y()*2)))
						continue;
				//right top
				else if (fP.x()>Broodwar->mapWidth()/2 && fP.y()<Broodwar->mapHeight()/3
					&&(firstBT->x()>fP.x() || (firstBT->y()<fP.y()*2)))
						continue;
				//buttom left
				else if (fP.x()<Broodwar->mapWidth()/3 && fP.y()>Broodwar->mapHeight()/2
					&&(firstBT->x()<fP.x()*2 || (firstBT->y()>fP.y())))
						continue;
				//buttom right
				else if (fP.x()>Broodwar->mapWidth()/2 && fP.y()>Broodwar->mapHeight()/2
					&&(firstBT->x()>fP.x() || (firstBT->y()>fP.y())))
					continue;
				else{
					refer2=*firstBT;
					this->BTPostion.insert(refer2);
					break;
				}				
			}
		}
	}


	for (int x=0;x<=Broodwar->mapHeight();x++){
		for(int y=0;y<=Broodwar->mapWidth();y++){
			//if(x>125 && y>125)
			//	Broodwar->printf("can 128");
			nextBT = new TilePosition(x,y);
			int pass = 0;

			for each(TilePosition tp in BTPostion){
				/*int see = (int)nextBT->getDistance(tp);
				int see2 = (int)nextBT->getDistance(fP);*/
				if(((abs(nextBT->x()- tp.x())>=6 && abs(nextBT->y()- tp.y())>=6)
				||	(((int)nextBT->getDistance(tp)>15)&& (abs(nextBT->x()- tp.x())>=2 || abs(nextBT->y()- tp.y())>=2)))
				&& (int)nextBT->getDistance(fP)>=15 && (int)nextBT->getDistance(fP)<=25){
					pass++;
					continue;
			}
				//if((int)nextBT->getDistance(tp)>=7 && (int)nextBT->getDistance(fP)>13 && (int)nextBT->getDistance(fP)<21){
				//	pass++;
				//	continue;
				//}
				else 
					break;
			}	
				if((int)BTPostion.size()==pass){
					if((int)BTPostion.size()<5)
						BTPostion.insert(*nextBT);
				}				
		}
	}
	this->BTPostion.insert(sC);
	setTankSiegePosition();
}	


Chokepoint* ChokepointManager::getFirstChoke()
{
	return this->mfirstChokepoint;
}

Chokepoint* ChokepointManager::getSecondChoke()
{
	if(this->msecondChokepoint != NULL)
		return this->msecondChokepoint;
	else return NULL;
}

Chokepoint* ChokepointManager::getThirdChoke()
{
	if(this->mthirdChokepoint != NULL)
		return this->mthirdChokepoint;
	else return NULL;
}

std::set<TilePosition> ChokepointManager::firstCPBuilding()
{
	return this->BTPostion;
}

void ChokepointManager::bestSetPoint()
{
	earlyBestPoint = mfirstChokepoint->getCenter();
	if (mthirdChokepoint == NULL){
		lateBestPoint = msecondChokepoint->getCenter();
	}
	else{
		Position* temp = new Position((msecondChokepoint->getCenter().x()+mthirdChokepoint->getCenter().x())/2,(msecondChokepoint->getCenter().y()+mthirdChokepoint->getCenter().y())/2);
		lateBestPoint = *temp;
	}
}

void ChokepointManager::setTankSiegePosition()
{
	TilePosition* siegePosition = new TilePosition(0,0);
	BWAPI::WeaponType tankWeapon = WeaponTypes::Arclite_Cannon_Edmund_Duke;
	int tankMaxRange = tankWeapon.maxRange()/32;
	int tankMinRange = tankWeapon.minRange()/32;

	for (int x=0;x<=Broodwar->mapHeight();x++){
		for(int y=0;y<=Broodwar->mapWidth();y++){
			siegePosition = new TilePosition(x,y);
			if (siegePosition->getDistance(this->CCTilePosition)>50)
				continue;
			else{
				int DisToSC =(int)siegePosition->getDistance((TilePosition)msecondChokepoint->getCenter());
				if (DisToSC<=8 && DisToSC>1){
					//Broodwar->printf("(%d,%d)",x,y);
					if (Broodwar->getRegionAt(x*32,y*32)->isHigherGround()){
						this->SiegePostionSet.insert(*siegePosition);
					}
				}
			}		
		}
	}
	if (this->SiegePostionSet.size()>1){
		int DisToCCTile = 99999;
		for each(TilePosition tp in this->SiegePostionSet){
			if (tp.getDistance(CCTilePosition)<DisToCCTile){
				DisToCCTile = (int)tp.getDistance(CCTilePosition);
				this->bestSiegeTile = tp;
			}
		}
	}
	else if((int)this->SiegePostionSet.size()==1)
		for each(TilePosition tp in this->SiegePostionSet){
			this->bestSiegeTile = tp;
		}
	else if (this->SiegePostionSet.size()<=0){
		this->bestSiegeTile = (TilePosition)lateBestPoint;
	}
}

TilePosition ChokepointManager::getTankSiegePosition()
{
	return this->bestSiegeTile;
}

void ChokepointManager::setScoutManager(ScoutManager* scout){
	this->scm = scout;
}

void ChokepointManager::getEnemyChokePoints()
{	
	if(this->scm->enemyStartLocation!=NULL && this->finishEnemyChoke==false){
		this->efirstChokepoint = BWTA::getNearestChokepoint(this->scm->enemyStartLocation->getPosition());
		this->eBaseCenter =  BWTA::getRegion(this->scm->enemyStartLocation->getPosition())->getCenter();	
		//find second chokepoint
		std::set<BWTA::Chokepoint*>chokePointSet = BWTA::getChokepoints();
		double tempDis = 99999;
		for each(BWTA::Chokepoint* cp in chokePointSet){
			if(cp == this->efirstChokepoint)
				continue;		
			if(tempDis == 99999 || cp->getCenter().getDistance(this->efirstChokepoint->getCenter()) < tempDis){
				tempDis = cp->getCenter().getDistance(this->efirstChokepoint->getCenter());
				this->esecondChokepoint = cp;
			}
		}

		//find third chokepoint
		TilePosition* mapTileCenter = new TilePosition(BWAPI::Broodwar->mapHeight()/2,BWAPI::Broodwar->mapWidth()/2);
		Position* mapCenter = new Position((mapTileCenter->x()*32),(mapTileCenter->y()*32));
		double tempWidth =0;
		for each(BWTA::Chokepoint* cp in chokePointSet){			
			if(cp == this->efirstChokepoint || (cp == this->esecondChokepoint && this->esecondChokepoint != NULL))
				continue;
			else if (cp->getCenter().getApproxDistance(this->esecondChokepoint->getCenter())<600){
				if(cp->getWidth()>tempWidth){
					tempWidth = cp->getWidth();
					this->ethirdChokepoint = cp;
				}		
			}	
			else if(this->ethirdChokepoint == NULL) this->ethirdChokepoint = this->esecondChokepoint;
		}

		int dis=0;
		for each(BaseLocation* bl in BWTA::getBaseLocations()){
			if(bl==this->scm->enemyStartLocation||bl==BWTA::getStartLocation(Broodwar->self()))
				continue;
			if(dis ==0 || bl->getPosition().getApproxDistance(this->scm->enemyStartLocation->getPosition())<dis){
				dis = bl->getPosition().getApproxDistance(this->scm->enemyStartLocation->getPosition());
				this->enemyNearestExpansion = bl;
			}
		}
		this->finishEnemyChoke = true;
		//Broodwar->printf("finish analyse enemy chokepoints!");
	}
}


Position ChokepointManager::getMyBestSetPoint()
{
	return this->mBestSetPoint;

}

void ChokepointManager::onFrame()
{
	for each(Chokepoint* cp in ckpSet){
		Broodwar->drawCircleMap(cp->getCenter().x(),cp->getCenter().y(),3,Colors::Blue,true);
	}
	for each(BWTA::Region* r in rgSet){
		Broodwar->drawCircleMap(r->getCenter().x(),r->getCenter().y(),10,Colors::Red,true);
	}
}

void ChokepointManager::destroy()
{
	if (theChokePointManager) delete theChokePointManager;
}


void ChokepointManager::getRegionVertices()
{
	for each (BWTA::Region* reg in BWTA::getRegions())
	{
		BWTA::Polygon border = reg->getPolygon();
		set<Position> vertices;
		Vector2 v = Vector2(0,0);
		Position tmp;
		Polygon::iterator cur;
		Polygon::iterator pre = border.begin();
		for (Polygon::iterator cur = border.begin(); cur != border.end(); cur++)
		{
			v = (*cur) - (*pre);
			if (cur != border.begin() && v.approxLen() > 64)
			{
				for (int i = 1; i <= 1 + v.approxLen()/64; i++)
				{	
					tmp = v * (i * 64.0 / v.approxLen()) + *pre;
					if (tmp != *cur)
					{
						if (tmp.y() >= Broodwar->mapHeight()*32 - 64)
							tmp.y() = Broodwar->mapHeight()*32;
						vertices.insert(tmp);
						//Broodwar->drawCircleMap(tmp.x(),tmp.y(),2,Colors::Yellow,true);
					}
				}
			}
			pre = cur;
			vertices.insert(*cur);
		}
		this->regionVertices.insert(make_pair(reg,vertices));
	}
}

set<TilePosition> ChokepointManager::getDroppablePosition()
{
	set<TilePosition> dropReg;

	// only for Andromeda map
	if (Broodwar->mapName().find(string("Andromeda")) != string::npos)
	{
		dropReg.insert(TilePosition(35,24));
		dropReg.insert(TilePosition(92,24));
		dropReg.insert(TilePosition(92,102));
		dropReg.insert(TilePosition(35,102));
		return dropReg;
	}
	
	// other maps
	for (int i = 0; i < Broodwar->mapWidth(); i++)
	{
		for (int j = 0; j < Broodwar->mapHeight(); j++)
		{
			TilePosition tp = TilePosition(i,j);
			if (!ICEStarCraft::Helper::isWalkable(tp))
				continue;

			for each (BWTA::BaseLocation* b in BWTA::getBaseLocations())
			{
				if (Broodwar->getGroundHeight(tp) > Broodwar->getGroundHeight(b->getTilePosition())	&& tp.getDistance(b->getTilePosition()) <= 16)
				{
					if(!BWTA::isConnected(tp,b->getTilePosition()))
						dropReg.insert(tp);
				}
			}
		}
	}
	return dropReg;
}