#include "vsProtossRules.h"
using namespace std;
using namespace BWAPI;
using namespace BWTA;

TPTiming* theTPTiming = NULL;

TPTiming* TPTiming::create(){
	if (theTPTiming) return theTPTiming;
	return theTPTiming = new TPTiming();
}

void TPTiming::destroy(){
	if (theTPTiming) 
		delete theTPTiming;
}

TPTiming::TPTiming(){

	this->attackTimingMap.clear();
	//three timing 
	//first is 3tanks,8 vultures + marine
	this->attackTimingMap[1]=false;
	//second is 6 factories, supply used>100
	this->attackTimingMap[2]=false;
	//last is supply > 170
	this->attackTimingMap[3]=false;
	this->mInfo = MyInforManager::create();
	this->eInfo = EnemyInforManager::create();
}

void TPTiming::CheckTiming()
{
	if (Broodwar->getFrameCount()%24*5==0){
		int preAtkTime = (this->eInfo->killedEnemyNum - this->mInfo->myDeadArmy)*2*24;
		preAtkTime = preAtkTime > 0? preAtkTime : 0;
		int population = Broodwar->self()->supplyUsed()/2;
		int tank = SelectAll()(isCompleted)(Siege_Tank).size();
		int vulture = SelectAll()(isCompleted)(Vulture).size();
		int factory = SelectAll()(isCompleted)(Factory).size();
		double mFV = this->mInfo->myFightingValue().first;
		double mDV = this->mInfo->myFightingValue().second;
		double eFV = this->eInfo->enemyFightingValue().first;
		double eDV = this->eInfo->enemyFightingValue().second;
		bool eHasDK = (this->eInfo->EnemyhasBuilt(UnitTypes::Protoss_Dark_Templar,2)||this->eInfo->EnemyhasBuilt(UnitTypes::Protoss_Templar_Archives,2));
		bool mHasDetector = !SelectAll()(isCompleted)(Comsat_Station,Science_Vessel).empty();
		//first timing slot
		if ((Broodwar->getFrameCount()>24*60*7-preAtkTime) && Broodwar->getFrameCount()<24*60*11+preAtkTime){
			if (tank>=4 && vulture>=6 && mFV>eDV*1.2){
				if (eHasDK && mHasDetector){
					this->attackTimingMap[1] = true;
				}
				else if (!eHasDK){
					this->attackTimingMap[1] = true;
				}
			}
		}
		//times out
		if (this->attackTimingMap[1]==true && (Broodwar->getFrameCount()>24*60*11 || mFV < eFV)){
			this->attackTimingMap[1] = false;
		}

		//second timing slot
		if (Broodwar->getFrameCount()>24*60*10-preAtkTime && Broodwar->getFrameCount()<24*60*14+preAtkTime){
			if (population>=85 && factory>=4 && mFV>1.3*eFV){
				if (eHasDK && mHasDetector){
					this->attackTimingMap[2] = true;
				}
				else if (!eHasDK){
					this->attackTimingMap[2] = true;
				}
			}
		}
		//times out
		if (this->attackTimingMap[2]==true && mFV < eFV){
			this->attackTimingMap[2] = false;
		}


		//third timing slot

		//if (population >=160 && mFV>=1.5*eFV){
		//	this->attackTimingMap[3] = true;
		//}
		//else{
		//	if (this->attackTimingMap[3]&& mFV < eFV)
		//		this->attackTimingMap[3] = false;
		//}
			if (population >=180){
					this->attackTimingMap[3] = true;
			}
			else{
					if (this->attackTimingMap[3] && mFV < eFV && population <= 120)
						this->attackTimingMap[3] = false;
			}
	}
}