#pragma once
#include <BWAPI.h>
#include <BWTA.h>
#include "BuildOrderManager.h"
#include "InformationManager.h"
#include "WorkerManager.h"
#include "ScoutManager.h"
#include "Base.h"
#include "BaseManager.h"
#include "TerrainManager.h"
#include "UpgradeManager.h"
#include "MentalState.h"
using namespace BWAPI;
using namespace BWTA;
using namespace std;

class MentalClass;
class BuildOrderManager;
class UpgradeManager;
class ChokepointManager;

class GameFlow{

public:
	static GameFlow* create();
	static void destroy();

	void TZonFrame();
	void TPstart();
	void setManagers(BuildOrderManager* bom,UpgradeManager* um);
	void stopGasTimeSlotSet(int time1,int time2,int stoplevel,int resumelevel);
	void onUnitDiscover(Unit* u);
	void factoryAutoTrain(int limitV,int limitT,int limitG,int priV,int priT,int priG);
	void factoryTrainSet(int numV,int numT,int numG,int priV,int priT,int priG);
	void balanceArmyCombination();
	TilePosition* bunkerPosition;
	TilePosition secondBaseTile;
	void TTonFrame();
private:
	int stopGasTime;
	int resumeGasTime;
	int lastFrameCheck;
	int vulPri;
	int tankPri;
	int goliathPri;
	bool stopGasFlag;
	bool mapDroppable;
	BuildOrderManager* buildOrder;
	MyInforManager* myInfor;
	EnemyInforManager* enemyInfor;
	WorkerManager* worker;
	ScoutManager* scout;
	BaseManager* bmc;
	ChokepointManager* choke;
	UpgradeManager* upgradeManager;
	MentalClass* mental;
	

protected:
	GameFlow();
};