#pragma once
#include <BWAPI.h>
#include <BWTA.h>
#include <math.h>
#include "Vector2.h"

using namespace std;
using namespace BWAPI;
using namespace BWTA;

namespace ICEStarCraft
{
	class Helper
	{
	public:
		Helper(void);
		~Helper(void);

		static bool isWalkable(Position p);
		static bool isWalkable(TilePosition tp);
		static bool isWalkable(int walkX, int walkY);
		static bool isWalkable(Position cur, Position des);
		static bool isConnected(TilePosition tp1, TilePosition tp2);

    static bool nearReachPos(BWAPI::Unit* u, BWAPI::Position& p){return u->getPosition().getApproxDistance(p) < 8;}
    static bool nearReachPos(BWAPI::Unit* u, BWAPI::Position& p, int _thres){return u->getPosition().getApproxDistance(p) < _thres;}

		// get first principal component
		//static Vector2 getFPC(set<Unit*> units);

		static void drawPolygonVertices(BWTA::Region* r);
		static void drawRegionCenter(BWTA::Region* r);
		static bool isChokePointCenter(Position p);
		static bool isConnected(BWTA::Region* r1, BWTA::Region* r2);
		static BWTA::Chokepoint* getChokePoint(BWTA::Region* r1, BWTA::Region* r2);
	};


}
