#pragma once
#include <BWAPI.h>
#include <BWTA.h>
#include "BaseManager.h"
#include "Base.h"
#include "UnitGroup.h"
#include "UnitGroupManager.h"
#include "ScoutManager.h"
using namespace BWAPI;
using namespace BWTA;
using namespace std;

class BaseManager;
class ScoutManager;

class MyInforManager
{
public:
	int myDeadArmy;
	int myDeadWorker;
	static MyInforManager* create();
	static void destroy();
	std::pair<double,double> myFightingValue();
	void setUsefulManagers(BaseManager* baseManager);
	int getMyPopulation();
	int getMyBaseNum();
	int getMyArmyNum();
	int CountUnitNum(UnitType uType,int complete);
//	void onUnitDestroy(BWAPI::Unit* u);
	void onUnitDiscover(Unit* u);
	void myInfoOnFrame();
	void onUnitDestroy(Unit* u);
	bool needScanNow;
	UnitGroup allMyFighter;
protected:
	MyInforManager();
private:
	set<Unit*> allmyUnits;
	BaseManager* bmc;
};

class EnemyInforManager
{
public:
	int enemyDeadWorker;
	static EnemyInforManager* create();
	static void destroy();
	void onFrame();
	void showTypeToTimeMap();
	void showUnitToTypeMap();
	void showBuildingToPositionMap();
	void showBaseToDataMap();
	bool EnemyhasBuilt(UnitType uType,int n);
	void onUnitDiscover(Unit* u); 
	void onUnitMorph(BWAPI::Unit* u);
	void onUnitDestroy(Unit* u);
	pair<int,Position>  getLastSeenEnemyArmy(UnitGroup ug);
	int  getEnemyBaseNum();
	int  getKilledEnemyNum();
	void unitTypeInfer(Unit* u);
	int CountEunitNum(UnitType uType);
	int timeToDefendMutalisk(Unit* u);
	bool drRangeUpgradeFlag;
	std::pair<double,double> enemyFightingValue();
	void enemyMainBaseConfirm();
	bool eMainBaseCheck;

	
	class eBaseData{
	public:
		eBaseData();
		bool checkFinish;
		UnitType uType;
		double currentTime;
		double finishTime;
		int startBuildTime;
		double ProgressRate;
		TilePosition tPosition;
		Position position;
		bool isStartBase;
		bool isMainBase;
	};
	map<Unit*,eBaseData> getEnemyBaseMap();
	bool needScanNow;
	bool showTypeToTime;
	bool showUnitToType;
	bool showBuildingToPosition;
	bool showBaseToData;
	int killedEnemyNum;
	map<UnitType,pair<int,bool>> eUnitTypeToTimeMap;
	map<Unit*,UnitType> eUnitToUintTypeMap;
	map<Unit*,UnitType> allenemyFighter;
	map<Unit*,std::pair<UnitType,Position>> eBuildingPositionMap;
	map<Unit*,eBaseData> enemyBaseMap;
	MyInforManager* mInfor;
protected:
	ScoutManager* scm;
	EnemyInforManager();

};


bool hasUnitType(UnitType uType,Player* player);