#pragma once
#include <BWTA.h>
#include <BWAPI.h>
#include "UnitGroup.h"
#include "UnitGroupManager.h"
#include "BuildOrderManager.h"
#include <TerrainManager.h>
#include "CommandRewrite.h"
#include "ScoutManager.h"
#include "InformationManager.h"
#include <MentalState.h>
#include "GameFlow.h"
#include <string.h>
#include "BaseManager.h"
#include "Base.h"

using namespace std;
using namespace BWAPI;
using namespace BWTA;

class ScoutManager;
class MentalClass;
class BaseManager;
class GameFlow;
class ChokepointManager;

class StrategyReaction
{
public:
	static StrategyReaction* create();
	static void destroy();

	void setUsefulManagers(BuildOrderManager* bom);
	void defendDK();
	void defendDropArmy();
	void defendRush();
	void defendReaver();
	void defendMutalisk();
	void defendLurker();
	void defendLargeScaleDrop();
	void protectBase();
	void rescueBase();
	void pushForward();
	void sealEnemy();
	void pushToPosition();
	void vultureControlMap();
//common command
	void allUnitAttack(Unit* eu,Position p);
	void groupUnitAttack(UnitGroup group, Position p);
	void DestroySpecifiedUnit(UnitGroup group,Unit* target);
	void onUnitDestroy(Unit* u);
	void onUnitDiscover(Unit* unit);
	void normalTVPDefend();
	void ChokepointBattleController(Position atkTar, BWTA::Chokepoint* theChokePoint);
	void NormalBattleController();
	void TZMacro();
	issueOnce* onceCommand;
	void ChokePointBlockSolution();
	UnitGroup goOutGroup ;
	UnitGroup highGroundSiegeTank(UnitGroup myTank,int limitNum);
	void tankAttackMode(Unit* tk,Position p);
	void allBuildingSetPoint(Position setposition);
	void ScanInvisibleEnemy();
	void findRestEnemy();
	void ScienceVesselBehavior();
	void ScienceVesselBehavior(Unit* u);
	void showScanPositionTable();
	bool setScanTableFlag(bool b);
	void minetest();
	void unitAvoidMine(UnitGroup ug,Position p);
	int unitGroupCenterLimitation;
	UnitGroup vultureGroup;
	TilePosition startTP;
	TilePosition endTP;
	void MiningRouteInitialization();
	std::pair<std::string,Position> attTar;
	TilePosition lastMineStart;
	TilePosition lastMineEnd;
	std::map<Unit*,Position> TankDefBase;
	UnitGroup TankDrop;
	void TvTTankProtectBase();
	void occupyPosition(Position p);
	bool occupyFlag;
	void TvTStrategy();
	UnitGroup allAttackUnits;
	UnitGroup myBattleUnits;    //our units that take part in the battle (a part of allAttackUnits)
	UnitGroup enemyBattleUnits; //enemy units that take part in the battle
	void keepFormationAttack(Unit* u);
	void BattlecruiserBehavior();
	//UnitGroup ttBlockTeam;
	//UnitGroup ttrescueTeam;
	Unit* theMarine;
	Unit* toGoIn;
	Unit* theDropship;
	TilePosition dropPos;
	TilePosition dropBaseCen;
	bool tankLoaded;
	bool tankSieged;
protected:
	StrategyReaction();

private:
	BaseManager* baseManager;
	int mLastCommandTime;
	Position mLastCommandPosition;
	BuildOrderManager* bom;
	EnemyInforManager* eInfo;
	MyInforManager* mInfo;
	MentalClass* mental;
	ChokepointManager* mChokePoint;
	std::set<Unit*> mDefendTeam;
	int DefendTeamSize;
	int btCount;
	std::set<TilePosition> receivedBTPositions;
	std::set<Unit*> allEnemyUnits;
	UnitGroup allVisibleEnemy;
	Position CCPosition;
	int highGroundTankLimitation;
	Position nextSetPoint;

	int lastScanTime;
	Position lastScanPosition;
	int lastTourMapTime;
	std::map<Position,std::pair<bool,int>> positionTOattack;
	std::set<Position> lastAttackPosition;
	ScoutManager* scm;
	bool desEnemyMainBase;
	std::set<Unit*> searchingUnits;
	 // for allunitattack() function
	bool scanTableFlag;
	Position* groupCenter;
	GameFlow* gf;
	UnitGroup battleC;
	Position gatherPoint;
	//std::map<Unit*,int> liftedB;

};

