#pragma once
#include <BWAPI.h>
#include <BWTA.h>
#include "BaseManager.h"
#include "Base.h"
#include "UnitGroup.h"
#include "UnitGroupManager.h"
#include "InformationManager.h"
#include "ScoutManager.h"
#include "MacroUnitControl.h"
#include "TerrainManager.h"
#include "WorkerManager.h"
#include "GameFlow.h"
#include "vsProtossRules.h"
#include "UpgradeManager.h"
#include "TechManager.h"
using namespace BWAPI;
using namespace BWTA;
using namespace std;

class StrategyReaction;
class ScoutManager;
class MyInforManager;
class EnemyInforManager;
class BuildOrderManager;
class ChokepointManager;
class TPTiming;
class UpgradeManager;
class TechManager;

class MentalClass{
public:
	static MentalClass* create();
	static void destroy();

	enum eRace{
		P,
		T,
		Z
	};
	enum eStrategyType{
		NotSure,
		PrushZealot,
		PrushDragoon,
		PtechDK,
		PtechReaver,
		BeCareful,
		P2Base,
		ZrushZergling,
		Ztech,
		Zexpansion,
		TrushMarine,
		Ttech,
		Texpansion,

	};
	void setManagers(BuildOrderManager* b,UpgradeManager* upgradeMng,TechManager* tech);
	void setEnemyPlanFlag();
	void counterMeasure();
	void baseUnderAttack();
	bool getUnderAttackFlag();
	void onUnitDestroy(BWAPI::Unit* u);
	void onUnitEvade(BWAPI::Unit* u);
	void onUnitMorph(BWAPI::Unit* u);
	void upDateSightRange();
	UnitGroup allMyUnits;
	UnitGroup enemyInSight;
	bool goAttack;
	bool waitBeforeAttack;
	bool scoutBeforeAttack;
	void attackTimingCheck();
	void TvPAttackTiming();

	int baseSightRangeLimitation;
	int armySightRangeLimitation;
	eStrategyType STflag;
	bool marineRushOver;
protected:
	MentalClass();
private:
	
	UpgradeManager* upgradeMng;
	MyInforManager* myInfor;
	EnemyInforManager* enemyInfo;
	BuildOrderManager* bom;
	ScoutManager* scm;
	bool openCheckFlag;
	StrategyReaction* str;
	bool reactionFinish;
	ChokepointManager* chokeclass;
	int	prushTimer1;
	bool mUnderAttack;
	bool emergencyFlag;
	WorkerManager* worker;
	GameFlow* gf;
	TPTiming* tpTiming;
	TechManager* techMng;

};