#pragma once
#include <BWAPI.h>
#include <BWTA.h>
#include "ScoutManager.h"
#include "Vector2.h"
#include "Helper.h"

using namespace BWAPI;
using namespace BWTA;
class ScoutManager;
class ChokepointManager{

public:
	
	static ChokepointManager* create();
	static void destroy();

	void setScoutManager(ScoutManager* scout);
	void setUsefulChokepoint();
	Chokepoint* getFirstChoke();
	Chokepoint* getSecondChoke();
	Chokepoint* getThirdChoke();
	std::set<TilePosition> firstCPBuilding();
	void bestSetPoint();
	Position earlyBestPoint;
	Position lateBestPoint;
	void setTankSiegePosition();
	TilePosition getTankSiegePosition();
	void getEnemyChokePoints();
	Position getMyBestSetPoint();
	Chokepoint* efirstChokepoint;
	Chokepoint* esecondChokepoint;
	Chokepoint* ethirdChokepoint;
	Position eBaseCenter;
	BaseLocation* enemyNearestExpansion;
	void onFrame();
	std::set<Chokepoint*> ckpSet;
	std::set<BWTA::Region*> rgSet;
	Position mBestSetPoint;
	Position mBestSetPoint2;
	Position mBestGatherPoint;
	map<BWTA::Region*,set<Position>> regionVertices;
	void getRegionVertices();
	set<TilePosition> dropReg;
	set<TilePosition> getDroppablePosition();
protected:	
	ChokepointManager();
private:
	bool finishEnemyChoke;
	ScoutManager* scm;
	Chokepoint* mfirstChokepoint;
	Chokepoint* msecondChokepoint;
	Chokepoint* mthirdChokepoint;

	std::set<TilePosition> BTPostion ;
	Position CCPosition;
	TilePosition CCTilePosition;
	std::set<TilePosition> SiegePostionSet ;
	TilePosition bestSiegeTile;


};



