#include <algorithm>
#include "WorkerManager.h"
#include "BaseManager.h"
#include <BWTA.h>
#include "UnitGroup.h"
#include "UnitGroupManager.h"
using namespace BWAPI;
using namespace BWTA;
using namespace std;

WorkerManager* theWorkerManager = NULL;

WorkerManager* WorkerManager::create(){
	if (theWorkerManager) 
		return theWorkerManager;
	else{
		theWorkerManager = new WorkerManager();
		return theWorkerManager;
	}	
}

void WorkerManager::destroy()
{
	if (theWorkerManager) delete theWorkerManager;
}

WorkerManager::WorkerManager()
:_mineralPS(0),
_mineralPM(0),
_averageMineralPS(0),
_averageMineralPM(0)

{
	// Initialize the counters for minerals per second, or per minute:
	for(int i = 0;i<61;i++) _accumluatedMinerals[i]=50;
	_lastFrameCount = GetTickCount();

//********************previous code
	this->bmc = NULL;

	/*setBaseManagerClass(bmc);
	set<BWAPI::Unit*> allMyMineral = this->bmc->getMyMineralSet();
	for(UnitSet::const_iterator i=allMyMineral.begin();i!=allMyMineral.end();i++) {
			_mineralsExploitation[*i].first = 0;
			_mineralsExploitation[*i].second = (int)Broodwar->self()->getStartLocation().getDistance((*i)->getTilePosition()) ;
	
		
	}*/
	this->mineralRate       = 0;
	this->gasRate           = 0;
	
	_workerState.clear();
	_workerBuildOrder.clear();
	_workerBuildingRefinery.clear();
	this->rebalancing = false;
	this->autoBuild         = false;
	this->autoBuildPriority = 65;
	this->optimalWorkerCount = 0;
	this->WorkersPerGas = -1;
	this->needTotalWorkerNum = 0;
	this->currentNum =0;
	this->lastNum = 0;
	this->allMineral = Broodwar->getMinerals();
	this->lastRebalanceTime = 0;
	this->repairGroup.clear();
	this->repairList.clear();
	this->scvDefendTeam.clear();
	this->enemyToDefend.clear();
	this->constructingSCV.clear();
	this->mental=MentalClass::create();
	this->gf=NULL;
	this->mInfo = NULL;
	this->eInfo = NULL;
	repairGroupSize = 1;
};

void WorkerManager::setBaseManagerClass(BaseManager* bmc)
{
	this->bmc = bmc;
	this->gf = GameFlow::create();
	this->mInfo = MyInforManager::create();
	this->eInfo = EnemyInforManager::create();
}



void WorkerManager::addUnit(Unit* newWorker) 
{
	_workerUnits.insert(newWorker);	  
	WorkerData temp;
	workers.insert(make_pair(newWorker,temp));
	for each(BaseClass* bc in this->bmc->getBaseSet()){
		if (bc->getCurrentWorkerNum() >= bc->getNeedWorkerNum()){
			Unit* bestMineral = getBestGlobalMineral();
			if (!bestMineral) continue;
			_workersTarget[newWorker] = bestMineral;			
			_workerState[newWorker] = Gathering_Mineral;
			// increase mineral exploitation
			_mineralsExploitation[bestMineral].first = _mineralsExploitation[bestMineral].first++;//every time this mineral being target,then score+1,in order to find next best mineral
			_mineralsExploitation[bestMineral].second = _mineralsExploitation[bestMineral].second + 5;// every time this mineral's distance being measured, then distance+5,in order to find next best mineral 
		}
		
		else if (bc->getCurrentWorkerNum() < bc->getNeedWorkerNum()){
			Unit* bestMineral = getBestLocalMineral(bc);
			if (!bestMineral) continue;
			if (newWorker->getTilePosition().getDistance(bestMineral->getTilePosition()) > 15)
				continue;
			else{
			_workersTarget[newWorker] = bestMineral;
			_workerState[newWorker] = Gathering_Mineral;
			// increase mineral exploitation
			_mineralsExploitation[bestMineral].first = _mineralsExploitation[bestMineral].first++;//every time this mineral being target,then score+1,in order to find next best mineral
			_mineralsExploitation[bestMineral].second = _mineralsExploitation[bestMineral].second + 5;// every time this mineral's distance being measured, then distance+5,in order to find next best mineral
			}	
		}
	}
	//for exception
	if (_workersTarget[newWorker]==NULL||!_workersTarget[newWorker]->exists()){
		if (!this->bmc->getAllMineralSet().empty()){
			Unit* mMineralPitch = (*this->bmc->getAllMineralSet().begin());
			_workersTarget[newWorker] = mMineralPitch;
		}
		//if we are mined out,find a visible mineral to him
		else{
			for (std::set<BWAPI::Unit*>::const_iterator it = allMineral.begin(); it != allMineral.end(); it++){
				if ((*it)->isVisible() && (*it)->exists()){
					_workersTarget[newWorker] = (*it);
					return;
				}
				else continue;
			}
		}
	}
	
	//// assign best mineral
	//Unit* bestMineral = getBestMineral();
	//_workersTarget[newWorker] = bestMineral;
	//_workerState[newWorker] = Gathering_Mineral;
	//// increase mineral exploitation
	//_mineralsExploitation[bestMineral].first = _mineralsExploitation[bestMineral].first++;//every time this mineral being target,then score+1,in order to find next best mineral
	//_mineralsExploitation[bestMineral].second = _mineralsExploitation[bestMineral].second + 5;// every time this mineral's distance being measured, then distance+5,in order to find next best mineral 
}



Unit* WorkerManager::getBestGlobalMineral()
{
	set<BaseClass*> trybase = this->bmc->getBaseSet();
	int bestScore;
	Unit* bestMineral;
	int shortestDis;
	for (set<BaseClass*>::iterator b=trybase.begin(); b!=trybase.end();b++){	
	
		set<Unit*> thisBaseMineral = (*b)->getMinerals();
		bestScore = 999;
		bestMineral = 0;
		shortestDis = 999999999;
	
		//add new minerals to global set
		for each(Unit* u in thisBaseMineral)
		{
			if (_mineralsExploitation.find(u)==_mineralsExploitation.end())
				_mineralsExploitation.insert(make_pair(u,make_pair(0,(int)(*b)->getBaseLocation()->getTilePosition().getDistance(u->getTilePosition()))));	
		}
		if ((*b)->getCurrentWorkerNum()>=(*b)->getNeedWorkerNum())
			continue;
		else{
			for (ResourceToWorkerMap::iterator j = _mineralsExploitation.begin(); j != _mineralsExploitation.end(); j++){
				if (thisBaseMineral.find(j->first) == thisBaseMineral.end())
					continue;
				else{
					if (j->second.first <= bestScore){
						bestScore = j->second.first;
						if ((*b)->getBaseLocation()->getTilePosition().getDistance(j->first->getTilePosition()) < shortestDis){
							shortestDis  = j->second.second;
							bestMineral = j->first;	
						}
					}
				}
			}
			if (bestMineral==0)
				return 0;
			else{
				//Broodwar->printf("global!");
				return bestMineral;
			}
		}	
	}	
		//Broodwar->printf("can not find bestMineral!");
		ResourceToWorkerMap::iterator j = _mineralsExploitation.begin();
		return j->first;
}

Unit* WorkerManager::getBestLocalMineral(BaseClass* b){
	//set<BaseClass*> trybase = this->bmc->getBaseSet();
	int bestScore;
	Unit* bestMineral;
	int shortestDis;
//	for (set<BaseClass*>::iterator b=trybase.begin(); b!=trybase.end();b++){	
		
		set<Unit*> thisBaseMineral = b->getMinerals();
		bestScore = 999;
		bestMineral = 0;
		shortestDis = 999999999;

		//add new minerals to global set
		for each(Unit* u in thisBaseMineral)
		{
			if (_mineralsExploitation.find(u)==_mineralsExploitation.end())
				_mineralsExploitation.insert(make_pair(u,make_pair(0,(int)b->getBaseLocation()->getTilePosition().getDistance(u->getTilePosition()))));	
		}

		//if this base not need worker any more, then produce worker for global use
		

		//if this base still need worker, then produce for itself
			for (ResourceToWorkerMap::iterator j = _mineralsExploitation.begin(); j != _mineralsExploitation.end(); j++){
				if(thisBaseMineral.size()<=0)
					break;
				if (thisBaseMineral.find(j->first) == thisBaseMineral.end())
					continue;
				else{
					if (j->second.first <= bestScore){
						bestScore = j->second.first;
						if (b->getBaseLocation()->getTilePosition().getDistance(j->first->getTilePosition()) < shortestDis){
							shortestDis  = j->second.second;
							bestMineral = j->first;	
						}
					}
				}
			}
			if (bestMineral==0)
				return NULL;
			else{
				//Broodwar->printf("local!");
				return bestMineral;
			}
	//Broodwar->printf("can not find bestMineral!");
	ResourceToWorkerMap::iterator j = _mineralsExploitation.begin();
	return j->first;
}
void WorkerManager::microBalance()
{
	set<BaseClass*> allBaseSet = this->bmc->getBaseSet();
    
	if (Broodwar->getFrameCount()%30 == 0 && WorkersPerGas != -1 && this->rebalancing == false){
		set<Unit*> baseGeysers;
		for (set<BaseClass*>::const_iterator b = allBaseSet.begin();b!= allBaseSet.end();b++){	
				(*b)->setWorkerconfig();
			baseGeysers = (*b)->getGeysers();
			for(set<Unit*>::iterator g = baseGeysers.begin(); g != baseGeysers.end(); g++){
				int temp = 0;
				if ((*b)->getGasWorkerNum() < this->WorkersPerGas && (*g)->getType().isRefinery() && (*g)->getPlayer()==Broodwar->self() && (*g)->isCompleted()){
					temp = this->WorkersPerGas-(*b)->getGasWorkerNum();
					std::map<BWAPI::Unit*,std::set<BWAPI::Unit*>> workerToBase = (*b)->getWorkerNearBaseSet();
					if (!workerToBase.empty()){
						for each(Unit* scv in workerToBase.begin()->second){
							if(temp == 0) break;
							if (scv->isCarryingMinerals() || scv->isGatheringGas() || scv->isGatheringGas()||scv->isConstructing()) continue;
							else{
								_workersTarget[scv] = (*g);
								_workerState[scv] = Gathering_Gas;
								scv->rightClick(*g);
								temp--;
							}
						}			
					}
				}
				else if ((*b)->getGasWorkerNum() > this->WorkersPerGas&& (*g)->getType().isRefinery() && (*g)->getPlayer()==Broodwar->self() && (*g)->isCompleted()){
					temp = (*b)->getGasWorkerNum() - this->WorkersPerGas;
					std::map<BWAPI::Unit*,std::set<BWAPI::Unit*>> workerToBase = (*b)->getWorkerNearBaseSet();
					if (!workerToBase.empty()){
						for each (Unit* scv in workerToBase.begin()->second){
							if(temp == 0) break;
							if(scv->isGatheringGas() || scv->isCarryingGas()){
								_workersTarget[scv] = getBestLocalMineral(*b);
								_workerState[scv] = Gathering_Mineral;
								scv->rightClick(_workersTarget[scv]);
								temp--;
							}

						}
					}

				}
			}
		}
	}



	
	if (allBaseSet.size() >= 2 && Broodwar->getFrameCount()%300 == 0 && this->rebalancing == false){

		set<BaseClass*> baseNeedWorker;
		set<BaseClass*> baseProvideWorker;
		baseNeedWorker.clear();
		baseProvideWorker.clear();

		//divide bases
		for (set<BaseClass*>::const_iterator b = allBaseSet.begin();b!= allBaseSet.end();b++){
			(*b)->setWorkerconfig();
			// for dangerous base or lifted base
			if ((*b)->getCurrentWorkerNum()>(*b)->getNeedWorkerNum()){
				baseProvideWorker.insert(*b);
				//Broodwar->printf("Base (%d,%d) over %d workers",(*b)->getBaseLocation()->getTilePosition().x(),(*b)->getBaseLocation()->getTilePosition().y(),(*b)->getOverWorkerNum());
			}		

			else if ((*b)->getCurrentWorkerNum() == (*b)->getNeedWorkerNum()) continue;
			else{
				baseNeedWorker.insert(*b);
				//Broodwar->printf("Base (%d,%d) lack %d workers",(*b)->getBaseLocation()->getTilePosition().x(),(*b)->getBaseLocation()->getTilePosition().y(),(*b)->getLackWorkerNum());
			} 	
		}

		for each(BaseClass* bc in baseProvideWorker){
			if (bc->getOverWorkerNum() <= 0){			
				continue;
			}
			else{
				for each(BaseClass* bc2 in baseNeedWorker){
					if (bc2->getLackWorkerNum() <= 0){
						continue;
					}
					else if (bc2->getLackWorkerNum() > 0){
						std::set<Unit*> mPatch = bc2->getMinerals();
						std::set<Unit*> ProviderSet;
						if (!bc->getWorkerNearBaseSet().empty()) {
							ProviderSet = bc->getWorkerNearBaseSet().begin()->second;
						}
						int i = 0;
						int j = bc->getOverWorkerNum();// limit transfer worker num, in case of too many workers transfer at one time
						for (std::set<Unit*>::const_iterator it = mPatch.begin(); it != mPatch.end(); it++){
							if (bc->getOverWorkerNum() <= 0) break;
							for (std::set<Unit*>::iterator it2 = ProviderSet.begin(); it2 != ProviderSet.end(); it2++ ){
								if (j <= 0) break;
								else if (_workerUnits.find(*it2) != _workerUnits.end()&& !(*it2)->isGatheringGas()){
									_workersTarget[*it2]=(*it);
									(*it2)->rightClick(*it);
									ProviderSet.erase(*it2);
									i++;
									j--;
									break;
								}
							}
						}
						//Broodwar->printf("%d Workers are transfered from Base (%d,%d) to Base (%d,%d)",i,bc->getBaseLocation()->getTilePosition().x(),
						//	bc->getBaseLocation()->getTilePosition().y(),bc2->getBaseLocation()->getTilePosition().x(),bc2->getBaseLocation()->getTilePosition().y());
						break;
					}
				}

			}
		}
	}

}
void WorkerManager::rebalanceGathering()
{	
	if(Broodwar->getFrameCount()%5 != 0)
		currentNum = this->bmc->getBaseSet().size();
	if(Broodwar->getFrameCount()%5 == 0)
		lastNum = this->bmc->getBaseSet().size();
	//check the change of base number
	if (currentNum != lastNum && currentNum!=0 && lastNum!=0){
		if (lastRebalanceTime==0 || Broodwar->getFrameCount()-lastRebalanceTime>=24*60){
			//setNeedGasLevel(3);
			//Broodwar->printf("Base Num is %d, begin to rebalance",this->bmc->getBaseSet().size());
			this->rebalancing = true;
			int transferSCV=0;
			int remainSCV=0;

			set<BaseClass*> allBaseSet = this->bmc->getBaseSet();
			set<BaseClass*> baseNeedWorker;
			set<BaseClass*> baseProvideWorker;
			baseNeedWorker.clear();
			baseProvideWorker.clear();

			//divide bases
			for (set<BaseClass*>::const_iterator b = allBaseSet.begin();b!= allBaseSet.end();b++){
				(*b)->setWorkerconfig();
				if ((*b)->getNeedMoreWorker())
					baseNeedWorker.insert(*b);

				else if ((*b)->getCurrentWorkerNum() > (int)(*b)->getMinerals().size())
					baseProvideWorker.insert(*b);
			}

			//	Broodwar->printf("Divide base over!");
			for each (BaseClass* bc in baseProvideWorker){
				if (bc->getCurrentWorkerNum() - (int)bc->getMinerals().size() < 5)
					continue;
				else
					transferSCV+=7;
			}

			for each(BaseClass* bc2 in baseNeedWorker){
				std::set<Unit*> mPatch = bc2->getMinerals();
				UnitGroup transGroup = SelectAll()(isCompleted)(SCV).not(isGatheringGas);
				int i = transferSCV;
				for (std::set<Unit*>::const_iterator it = mPatch.begin(); it != mPatch.end(); it ++){
					if (i<=0)
						break;
					for (std::set<Unit*>::iterator it2 = transGroup.begin(); it2 != transGroup.end(); it2++ ){
						if (_workerUnits.find(*it2) != _workerUnits.end()){
							_workersTarget[*it2]=(*it);
							(*it2)->rightClick(*it);
							transGroup.erase(*it2);
							i--;
							break;
						}
					}
				}
			}

		lastRebalanceTime = Broodwar->getFrameCount();
	//	autoBuildWorker();
		}
		

	}

	this->rebalancing =false;
	
}
	
void WorkerManager::setBuildOrderManager(BuildOrderManager* buildOrderManager)
{
	this->buildOrderManager = buildOrderManager;
}		


void WorkerManager::onFrame() 
{
	//each base at least should have 10 workers, this is to prevent worker endless repair
	//ex: all workers dead for going to repair unit in dangerous place
	if (SelectAll()(isCompleted)(SCV).size()>10)
		workerRepair();	
	if (Broodwar->getFrameCount()%12==0){
		//for auto produing SCV
		autoTrainSCV();

		this->allMineral = Broodwar->getMinerals();
		if(this->bmc->checkflag == true){
			rebalanceGathering();
			microBalance();
		}
		this->mineralRate=0;
		this->gasRate=0;
		for(map<Unit*,WorkerData>::iterator u = workers.begin(); u != workers.end(); u++)
		{
			Unit* i = u->first;
			if (u->second.resource!=NULL)
			{
				if (u->second.resource->getType()==UnitTypes::Resource_Mineral_Field)
					mineralRate+=8/180.0;
				else
					gasRate+=8/180.0;
			}
		}

		//DEBUG("Update workers state");
		for(UnitSet::const_iterator worker=_workerUnits.begin();worker!=_workerUnits.end();worker++) {
			Unit* wk = *worker;
			if (wk->getOrder()==Orders::PlayerGuard){
				if(_workerState[wk]==Scouting)
					continue;		
				else if (wk->isIdle()&&_workerState[wk]!=Scouting){
					//if current worker is not null
					Unit* target = _workersTarget[wk];
					if (target){
						//check if this target is not exist 
						if (target->exists()){
							//if target is mineral
							if (target->getType().isMineralField()){
								//wk->rightClick(target);
								//continue;
								//if the target is not one of our minerals
								std::set<Unit*> mineralSet = this->bmc->getAllMineralSet();
								if (!mineralSet.empty()){
									if (mineralSet.find(target)==mineralSet.end()){
										Unit* mMineralPitch = *mineralSet.begin();
										_workersTarget[wk] = mMineralPitch;
										wk->rightClick(_workersTarget[wk]);
										continue;
									}
									else{
										if (wk->isCompleted())
											wk->rightClick(target);
										else
											continue;
									}									
								}
								else{
									if (wk->isCompleted())
										wk->rightClick(target);
									else
										continue;
								}		

							}
							else{
								//if it is not a mineral, then assign one of my mineral to him
								if (!this->bmc->getAllMineralSet().empty()){
									Unit* mMineralPitch = (*this->bmc->getAllMineralSet().begin());
									_workersTarget[wk] = mMineralPitch;
									wk->rightClick(_workersTarget[wk]);
								}
								//if we are mined out,find a visible mineral
								else{
									for (std::set<BWAPI::Unit*>::const_iterator it = allMineral.begin(); it != allMineral.end(); it++){
										if ((*it)->isVisible() && (*it)->exists()){
											_workersTarget[wk] = (*it);
											wk->rightClick(_workersTarget[wk]);
										}
										else continue;
									}
								}
							}
						}
						//if the worker even doesn't have any target
						else{
							//assign one of my mineral to him
							if (!this->bmc->getAllMineralSet().empty()){
								Unit* mMineralPitch = (*this->bmc->getAllMineralSet().begin());
								_workersTarget[wk] = mMineralPitch;
								wk->rightClick(_workersTarget[wk]);
							}
							//if we are mined out,find a visible mineral to him
							else{
								for (std::set<BWAPI::Unit*>::const_iterator it = allMineral.begin(); it != allMineral.end(); it++){
									if ((*it)->isVisible() && (*it)->exists()){
										_workersTarget[wk] = (*it);
										wk->rightClick(_workersTarget[wk]);
									}
									else continue;
								}
							}
						}
					}

					//if (_workersTarget[wk] &&_workersTarget[wk]->exists()&& _workersTarget[wk]->getResources()>0)
					//	wk->rightClick(_workersTarget[wk]);
					//else if ((!_workersTarget[wk] && (!_workersTarget[wk]->exists()||_workersTarget[wk]->getResources() == 0)) && wk->isIdle()){
					//	ResourceToWorkerMap::iterator j = _mineralsExploitation.begin();
					//	if (j->first && j->first->exists() && j->first->getResources()>0)				
					//		wk->rightClick(j->first);
					//	else{
					//		for (std::set<BWAPI::Unit*>::const_iterator it = allMineral.begin(); it != allMineral.end(); it++){
					//			if ((*it)->isVisible() && (*it)->exists()){
					//				wk->rightClick(*it);
					//				break;
					//			}
					//			else continue;
					//		}
					//	}
					//}
				}					
			}
		}
	}	
}

bool WorkerManager::needWorkers()
{	
	if (_workerUnits.size()<this->bmc->getAllMineralSet().size())
		return true;
	else
		return false;
}


int WorkerManager::getNeedTotalWorkerNum()
{
	this->needTotalWorkerNum = 0;

	if(this->bmc->checkflag == true){
		std::set<BaseClass*> bcset = this->bmc->getBaseSet();
		for (std::set<BaseClass*>::const_iterator i=bcset.begin(); i!=bcset.end();i++){
			if(this->bmc->checkflag==false){
				this->needTotalWorkerNum = (int)workers.size()+15;
				break;
			} 
			else{
				BaseClass* ii = *i;
				this->needTotalWorkerNum += ii->getNeedWorkerNum();
			}
			
		}
	}

	if (this->needTotalWorkerNum <80)
		return this->needTotalWorkerNum	;
	else
	{
		this->needTotalWorkerNum = 80;
		return this->needTotalWorkerNum	;

	}
}

unsigned int WorkerManager::getWorkersMining()
{
	// TODO: Optimize calculating on add/delete worker on mineral spot

	int workersMining = 0;
	for (UnitSet::const_iterator _workers =_workerUnits.begin();_workers!=_workerUnits.end();_workers++)
	{
		if (_workerState[(*_workers)]== Gathering_Mineral)
			workersMining++;
		else
			continue;
	}
	/*for(ResourceToWorkerMap::const_iterator mineral=_mineralsExploitation.begin();mineral!=_mineralsExploitation.end();mineral++) {
		workersMining += mineral->second.first;
	}*/
	return workersMining;

}

void WorkerManager::onUnitDestroy(Unit* unit)
{
	// Add something here
	this->enemyToDefend.erase(unit);
	this->workers.erase(unit);
	_workerUnits.erase(unit);
	scvDefendTeam.erase(unit);
	this->repairGroup.erase(unit);	
	this->repairList.erase(unit);
}

BWAPI::Unit* WorkerManager::getWorkerForTask(Position toPosition)
{
	return NULL;
	//to do
}



BWAPI::Position WorkerManager::getPositionToScout(Position myPos, BWTA::Region* myRegion, Position basePos, bool checkVisible)
{

	Position returnPosition;
	int maxDist = 17;
	//Broodwar->drawCircleMap(basePos.x(),basePos.y(),maxDist*TILE_SIZE,Colors::Yellow,false);
	TilePosition seedTilePos = TilePosition(myPos);
	TilePosition baseTilePos = TilePosition(basePos);
	int x      = seedTilePos.x();
	int y      = seedTilePos.y();
	int length = 1;
	int j      = 0;
	bool first = true;
	int dx     = 0;
	int dy     = 1;	
	while (length < Broodwar->mapWidth()) {
		returnPosition = Position(x*TILE_SIZE, y*TILE_SIZE);
		//check max distance
		if (returnPosition.getDistance(myPos) > maxDist*TILE_SIZE) {
			//if (x > baseTilePos.x()+maxDist && y > baseTilePos.y()+maxDist) {
			if (!checkVisible) return getPositionToScout(myPos, myRegion, basePos, true);
			else return basePos;
		}

		if (x >= 0 && x < Broodwar->mapWidth() && y >= 0 && y < Broodwar->mapHeight() && 
			myRegion == BWTA::getRegion(x,y) && Broodwar->hasPath(myPos,returnPosition) ) {
				//if (x <= baseTilePos.x()+maxDist && y <= baseTilePos.y()+maxDist) {
				if (!checkVisible) {
					if (!Broodwar->isExplored(x,y)) return returnPosition;
				} else {
					if (!Broodwar->isVisible(x,y)) return returnPosition;
				}
				//}
		}

		//otherwise, move to another position
		x = x + dx;
		y = y + dy;
		//count how many steps we take in this direction
		j++;
		if (j == length) { //if we've reached the end, its time to turn
			j = 0;	//reset step counter

			//Spiral out. Keep going.
			if (!first)
				length++; //increment step counter if needed

			first =! first; //first=true for every other turn so we spiral out at the right rate

			//turn counter clockwise 90 degrees:
			if (dx == 0) {
				dx = dy;
				dy = 0;
			} else {
				dy = -dx;
				dx = 0;
			}
		}
		//Spiral out. Keep going.
	}

	return basePos;
}

void WorkerManager::tryMiningTrick(Unit* worker)
{
	;
}

double WorkerManager::getMineralRate() const
{
	return this->mineralRate;
}
double WorkerManager::getGasRate() const
{
	return this->gasRate;
}

int WorkerManager::getOptimalWorkerCount() const
{
	return this->optimalWorkerCount;
}
void WorkerManager::enableAutoBuild()
{
	this->autoBuild=true;
}
void WorkerManager::disableAutoBuild()
{
	this->autoBuild=false;
}
void WorkerManager::setAutoBuildPriority(int priority)
{
	this->autoBuildPriority = priority;
}

void WorkerManager::setWorkerPerGas(int num)
{
	this->WorkersPerGas = num;
}


void WorkerManager::setNeedGasLevel(int level){

	set<BaseClass*> allBaseSet = this->bmc->getBaseSet();
	set<Unit*> baseGeysers;
	if (level == 0){
		this->WorkersPerGas = 0;
	}
	if (level == 1){
		this->WorkersPerGas = 1;
		for (set<BaseClass*>::const_iterator b = allBaseSet.begin();b!= allBaseSet.end();b++){	
			baseGeysers = (*b)->getGeysers();
			for(set<Unit*>::iterator g = baseGeysers.begin(); g != baseGeysers.end(); g++){
				Unit* _g = *g;
				if (Broodwar->canBuildHere(NULL,_g->getTilePosition(),UnitTypes::Terran_Refinery)&&!_g->getType().isRefinery()){
					//Broodwar->printf("can build refinery!");
					this->buildOrderManager->buildAdditional(1,UnitTypes::Terran_Refinery,200,_g->getTilePosition());
					
				}
				//else
					//Broodwar->printf("already has refinery on it!");

			}	
		}
	}
	if (level == 2){
		if(allBaseSet.size() == 1){
			this->WorkersPerGas = 3;
			for (set<BaseClass*>::const_iterator b = allBaseSet.begin();b!= allBaseSet.end();b++){	
				baseGeysers = (*b)->getGeysers();
				for(set<Unit*>::iterator g = baseGeysers.begin(); g != baseGeysers.end(); g++){
					Unit* _g = *g;
					if (Broodwar->canBuildHere(NULL,_g->getTilePosition(),UnitTypes::Terran_Refinery)&&!_g->getType().isRefinery())
						this->buildOrderManager->buildAdditional(1,UnitTypes::Terran_Refinery,200,_g->getTilePosition());
						
				}	
			}
		}
		else if (allBaseSet.size()>1){
			this->WorkersPerGas = 2;
			for (set<BaseClass*>::const_iterator b = allBaseSet.begin();b!= allBaseSet.end();b++){	
				baseGeysers = (*b)->getGeysers();
				for(set<Unit*>::iterator g = baseGeysers.begin(); g != baseGeysers.end(); g++){
					Unit* _g = *g;
					if (Broodwar->canBuildHere(NULL,_g->getTilePosition(),UnitTypes::Terran_Refinery)&&!_g->getType().isRefinery())
						this->buildOrderManager->buildAdditional(1,UnitTypes::Terran_Refinery,200,_g->getTilePosition());
						
				}	
			}
		}

	}
	if (level == 3){
		this->WorkersPerGas = 3;
		for (set<BaseClass*>::const_iterator b = allBaseSet.begin();b!= allBaseSet.end();b++){	
			baseGeysers = (*b)->getGeysers();
			for(set<Unit*>::iterator g = baseGeysers.begin(); g != baseGeysers.end(); g++){
				Unit* _g = *g;
				//&&!_g->getType().isRefinery()
				if (Broodwar->canBuildHere(NULL,_g->getTilePosition(),UnitTypes::Terran_Refinery)){
					if (this->buildOrderManager->getPlannedCount(UnitTypes::Terran_Refinery,90)<1+SelectAll()(isCompleted)(Command_Center).size()){
						this->buildOrderManager->build(SelectAll()(isCompleted)(Command_Center).size()+1,UnitTypes::Terran_Refinery,90,_g->getTilePosition());
					}
				}				
			}	
		}
	}	
}

void WorkerManager::autoBuildWorker()
{	
	int tmp=0;
	if (this->autoBuild == true && (int)_workerUnits.size() < (tmp=getNeedTotalWorkerNum())){
		if ((int)_workerUnits.size()<80){
			optimalWorkerCount = tmp;
			BWAPI::UnitType workerType=BWAPI::Broodwar->self()->getRace().getWorker();
			//
			if (this->buildOrderManager->getPlannedCount(workerType)<optimalWorkerCount)
			{
				int see=this->buildOrderManager->getPlannedCount(workerType);
				//this->buildOrderManager->deleteItem(workerType,this->autoBuildPriority);
				this->buildOrderManager->buildAdditional(optimalWorkerCount-see,workerType,this->autoBuildPriority);
			}
		}
	}
	else if (this->autoBuild ==false||(int)_workerUnits.size()>=80){
		BWAPI::UnitType workerType=BWAPI::Broodwar->self()->getRace().getWorker();
		this->buildOrderManager->deleteItem(workerType,this->autoBuildPriority);
	}
}


std::set<BWAPI::Unit*> WorkerManager::selectSCV(int n){
	std::set<BWAPI::Unit*> scvSet;
	scvSet.clear();
	int i =0;
	for (UnitSet::iterator it = _workerUnits.begin(); it!=_workerUnits.end();it++){
		Unit* scv = *it;
		if (i>=n)
			break;
		else if (this->constructingSCV.find(*it)!=this->constructingSCV.end())
			continue;
		else if (scv->isConstructing()||scv->isCarryingGas()||scv->isCarryingMinerals()||!scv->isCompleted())
			continue;		
		else if (scv->getLastCommand().getType()==UnitCommandTypes::Build||scv->getOrder()==Orders::ConstructingBuilding)
			continue;
		else{
			scvSet.insert(scv);
			_workerState[scv] = Scouting;
			 _workerUnits.erase(it);
			break;
		}
	}
	return scvSet;
}

void WorkerManager::workerRepair()
{
	//Broodwar->printf("repair team size:%d",this->repairGroup.size());
	//Broodwar->drawTextScreen(0,50,"repair team size: %d/%d",this->repairGroup.size(),repairGroupSize);
	//find damaged units or buildings, add to repairList
	for (std::set<Unit*>::const_iterator i = Broodwar->self()->getUnits().begin();i != Broodwar->self()->getUnits().end(); i++){
		Unit* u = *i;
		if (u->getType().isOrganic() || this->repairList.find(u) != this->repairList.end()|| u->isLifted())
			continue;
		else if (!u->isCompleted()||u->isBeingConstructed()||(u->getType().isBuilding()&&u->getTilePosition().getDistance(Broodwar->self()->getStartLocation())>50))
			continue;
		else if(u->isCompleted()){
			//for repair building
			if (u->getType().isBuilding() && u->getHitPoints() <= u->getType().maxHitPoints()/3)
				this->repairList.insert(u);
			//for repair bunker
			else if (u->getType()==UnitTypes::Terran_Bunker && u->getHitPoints() < u->getType().maxHitPoints())
				this->repairList.insert(u);
			//for repair mechanical units
			else if (u->getType()!= UnitTypes::Terran_Battlecruiser && u->getType().isMechanical() && (double)u->getHitPoints() <= (double)u->getType().maxHitPoints()*0.7)
				this->repairList.insert(u);
		}
	}
	//add battlecruiser team
	this->repairList+=SelectAll()(Battlecruiser)(isCompleted)(HitPoints,"<",250);

	//recognize which bunker to repair
	UnitGroup bunker = SelectAll()(isCompleted)(Bunker)(LoadedUnitsCount,">=",1);
	if (!bunker.empty() && (!this->mental->enemyInSight(canAttack).not(isWorker).empty()||Broodwar->getFrameCount()<=(24*60*8+24*45)) && gf->bunkerPosition){
		UnitGroup::iterator iter = bunker.begin();
		Unit* bk= *iter;
		iter ++;
		int minD = bk->getPosition().getApproxDistance(Position(*gf->bunkerPosition));
		while (iter!=bunker.end()) {
			int d = (*iter)->getPosition().getApproxDistance(Position(*gf->bunkerPosition));			
			if (d < minD && d < 32*20) {
				minD = d;
				bk = *iter;
			}
			iter ++;
		}
		
		// for emergency, enlarge repair group
		if (!this->mental->enemyInSight(canAttack).empty() &&
			this->mInfo->myFightingValue().first < this->eInfo->enemyFightingValue().first &&
			getGroupTargetPosition(this->mental->enemyInSight(canAttack)).getApproxDistance(bk->getPosition())<=32*7){
				repairGroupSize = 5;
				//select nearest scv to join the group
				int dis = 99999;
				Unit* newRepairSCV = NULL;
				if (this->repairGroup.size()<repairGroupSize){
					for(std::set<Unit*>::iterator scv =_workerUnits.begin();scv !=_workerUnits.end();scv++){
						Unit* u = *scv;
						if(u->isConstructing() || _workerState[u]==Scouting || u->isCarryingGas() || u->isCarryingMinerals())
							continue;
						else if (u->getPosition().getApproxDistance(bk->getPosition())<dis){
							dis = u->getPosition().getApproxDistance(bk->getPosition());
							newRepairSCV = u;
						}
					}
					//add the unit to repair group
					if (newRepairSCV){
						_workerUnits.erase(newRepairSCV);
						this->repairGroup.insert(newRepairSCV);
					}
				}
		}
		else{
			//after emergency, scv go back to work
			if (Broodwar->enemy()->getRace()==Races::Terran){
				if (repairList.empty())
					repairGroupSize = 0;
				else
					repairGroupSize = 2;
			}			
				
			else{
				if (repairList.empty())
					repairGroupSize = 1;
				else
					repairGroupSize = 2;
			}

			for(std::set<Unit*>::iterator scv = this->repairGroup.begin();scv != this->repairGroup.end();){
				if (this->repairGroup.size()<=repairGroupSize)
					break;
				else{
					_workerUnits.insert(*scv);
					scv = this->repairGroup.erase(scv);	
				}							
			}
		}		
	
		// add SCV to repair group
		if (Broodwar->enemy()->getRace()==Races::Terran && !SelectAll()(isCompleted)(Battlecruiser).empty())
		{
			int num = SelectAll()(isCompleted)(Battlecruiser)(HitPoints,"<",250).size();
			if (num < 4)
				repairGroupSize = 6;
			else if (num < 6)
				repairGroupSize = 9;
			else
				repairGroupSize = 12;
		}
		for each (Unit* scv in SelectAll()(isCompleted)(SCV))
		{
			if (this->repairGroup.size()<repairGroupSize)
				this->repairGroup.insert(scv);
		}

		for each(Unit* rw in this->repairGroup){
			if (_workerUnits.find(rw)!=_workerUnits.end()){
				_workerUnits.erase(rw);
				break;
			}
			//for scv waiting beside bunker, prepare for possible rush
			if (rw->getPosition().getApproxDistance(bk->getPosition())>=32*2 && Broodwar->getFrameCount()%24==0 && !rw->isRepairing()){
				if (rw->getPosition().getApproxDistance(bk->getPosition())<=32)
					continue;
				else
					rw->rightClick(bk->getPosition());
			}				
		}				
	}
	else{
		for each(Unit* rw in this->repairGroup){
			_workerUnits.insert(rw);
		}
	}


	//remove repaired units
	for(std::set<Unit*>::iterator i = repairList.begin(); i != repairList.end();){
		Unit* rt = *i;
		if (rt->getHitPoints() == rt->getType().maxHitPoints() && !rt->isUnderAttack()){
			i = repairList.erase(i);
		}
		else
			i++;					
	}

	// issue a repair command
	for each(Unit* repairTarget in repairList){
		if (repairTarget->getHitPoints() == repairTarget->getType().maxHitPoints() && !repairTarget->isUnderAttack())
			continue;		
		else if (!repairTarget->isUnderAttack() && repairTarget->isBeingHealed())
			continue;
		else if ((repairTarget->getType()==UnitTypes::Terran_Command_Center) 
			&& (!repairTarget->isBeingHealed()|| repairTarget->getHitPoints() != repairTarget->getType().maxHitPoints())){
				for each(Unit* repairWorker in repairGroup){
					if(repairWorker->isAttacking()||repairWorker->isRepairing()||repairWorker->isConstructing()||!repairWorker->isCompleted()||_workerState[repairWorker]==Scouting)
						continue;
					else
						repairWorker->repair(repairTarget);												
				}
		}
		else{
			for each(Unit* repairWorker in repairGroup){
				if(repairWorker->isAttacking()||repairWorker->isRepairing()||repairWorker->isConstructing()||!repairWorker->isCompleted()||_workerState[repairWorker]==Scouting)
					continue;
				else
					repairWorker->repair(repairTarget);												
			}
		}
	}
}

//void WorkerManager::scvDefendBase()
//{
//	double odur = UnitTypes::Terran_SCV.groundWeapon().damageAmount()*1.0/UnitTypes::Terran_SCV.groundWeapon().damageCooldown()*60;
//	BWTA::Region* baseReg = getRegion(Broodwar->self()->getStartLocation());
//	enemyToDefend = SelectAllEnemy()(isVisible).not(isFlyer,isLifted).inRegion(baseReg);
//
//	for (set<Unit*>::iterator i = scvDefendTeam.begin(); i!=scvDefendTeam.end();){
//		if (getRegion((*i)->getPosition()) != baseReg){	
//			_workerUnits.insert(*i);
//			if (_workersTarget[*i]!=NULL){				
//				(*i)->rightClick(_workersTarget[*i]);
//				i = scvDefendTeam.erase(i);
//			}
//			else
//				i++;				
//		}
//		else if((*i)->isConstructing()){
//			_workerUnits.insert(*i);
//			i = scvDefendTeam.erase(i);
//		}
//		else if((*i)->getHitPoints()<=15){
//			_workerUnits.insert(*i);
//			if (_workersTarget[*i]!=NULL){				
//				(*i)->rightClick(_workersTarget[*i]);
//				i = scvDefendTeam.erase(i);
//			}
//			else{
//				i++;
//				//if (_workersTarget[*i]!=NULL){
//				//	(*i)->rightClick(_workersTarget[*i]);
//				//	i = scvDefendTeam.erase(i);
//				//}
//			}		
//		}
//
//		else
//			i++; 
//	}
//	if(enemyToDefend.empty()){
//		for (set<Unit*>::iterator i = scvDefendTeam.begin(); i!=scvDefendTeam.end();){
//			_workerUnits.insert(*i);
//			if (_workersTarget[*i]!=NULL){				
//				(*i)->rightClick(_workersTarget[*i]);
//				i = scvDefendTeam.erase(i);
//			}
//			else
//				i++;			
//		}
//		return;
//	}
//	
//	// Only 1 scout
//	double edur = 0;
//	int buildingNum =0;
//	for each (Unit* u in enemyToDefend) {
//		UnitType t = u->getType();
//		if(t.isWorker())
//			edur += t.groundWeapon().damageAmount()*1.0/t.groundWeapon().damageCooldown()*(u->getHitPoints()+u->getShields()-1);
//		else if(t.isBuilding())
//			buildingNum++;
//		else if(t.groundWeapon().damageCooldown() != 0)
//			edur += t.groundWeapon().damageAmount()*2.0/t.groundWeapon().damageCooldown()*(u->getHitPoints()+u->getShields()-1);
//	}
//	//the number of scv we need 
//	int num = (int)(edur/odur) + 1 + buildingNum*2;
//	if ((int)scvDefendTeam.size() >= num) {
//		if ((int)scvDefendTeam.size() > num){	
//			UnitGroup::iterator i = scvDefendTeam.begin();
//			_workerUnits.insert(*i);
//			if (_workersTarget[*i]!=NULL){
//				(*i)->rightClick(_workersTarget[*i]);
//				scvDefendTeam.erase(i);
//			}
//			
//		}
//		Position p = enemyToDefend.getNearest(scvDefendTeam.getCenter())->getPosition();
//		for each (Unit* u in scvDefendTeam) {
//			if (!u->isAttacking()||u->getGroundWeaponCooldown()==0) u->attack(p);
//		}
//		return;
//	}
//	UnitGroup avaiWor = _workerUnits(HitPoints,">=",20)(isCompleted).not(isAttacking,isConstructing);
//	if (avaiWor.empty()) return;
//	for (set<Unit*>::iterator i = avaiWor.begin(); i!=avaiWor.end(); i++){
//		if (BWTA::getRegion((*i)->getPosition())!=baseReg)
//			continue;
//		scvDefendTeam.insert(*i);
//		_workerUnits.erase(*i);
//		if ((int)scvDefendTeam.size() >= num) break;
//	}
//	Position p = enemyToDefend.getNearest(scvDefendTeam.getCenter())->getPosition();
//	for each (Unit* u in scvDefendTeam) {
//		if (!u->isAttacking() ||u->getGroundWeaponCooldown()==0) u->attack(p);
//	}
//}

void WorkerManager::onUnitMorph(Unit* u)
{
	if (Broodwar->self()->isEnemy(u->getPlayer())){
		if (!u->getType().isBuilding() && (this->enemyToDefend.find(u))!=this->enemyToDefend.end())
			this->enemyToDefend.erase(u);
	}

}

void WorkerManager::onUnitHide(BWAPI::Unit* u)
{
	this->enemyToDefend.erase(u);
}

void WorkerManager::autoTrainSCV()
{
//	if (SelectAll()(SCV).size()<this->bmc->getAllMineralSet().size()*3){
		if (SelectAll()(isCompleted)(SCV).size()<=80){
			int pri = buildOrderManager->getPlannedCount(UnitTypes::Terran_SCV,this->autoBuildPriority+20);
			int need = bmc->getAllMineralSet().size()*2+bmc->getAllGeyserSet().size()*3+5;
			//Broodwar->printf("base number: %d,worker number:%d, need number:%d",bmc->getBaseSet().size(),SelectAll()(isCompleted)(SCV).size(),need);
			if (buildOrderManager->getPlannedCount(UnitTypes::Terran_SCV,this->autoBuildPriority+20)< need)
				this->buildOrderManager->build(need,UnitTypes::Terran_SCV,this->autoBuildPriority+20);
		}		

		else{
			if (this->buildOrderManager->getPlannedCount(UnitTypes::Terran_SCV,this->autoBuildPriority+20)<80)
				this->buildOrderManager->build(80,UnitTypes::Terran_SCV,this->autoBuildPriority+20);
		}		
//	}
}

void WorkerManager::onUnitDiscover(BWAPI::Unit* u)
{
	if (!u)
		return;
	if (u->getPlayer()==Broodwar->self() && u->getType().isWorker()){
		addUnit(u);	 
		/*
		if (Broodwar->enemy()->getRace()==Races::Terran){
			if (SelectAll()(isCompleted)(Battlecruiser).empty()){
				repairGroupSize = 0;
				if (this->repairGroup.size()<repairGroupSize)
					this->repairGroup.insert(u);
			}		
			else{
				repairGroupSize = 6;
				if (this->repairGroup.size()<repairGroupSize)
					this->repairGroup.insert(u);
			}
		}
		else{
			if (this->repairGroup.size()<repairGroupSize)
				this->repairGroup.insert(u);
		}
		*/
	}
}